<?php

namespace App\Jobs;

use App\Helpers\Helpers;
use App\Models\ErrorSintesi;
use App\Models\Sintesi;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldBeUnique;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;

use Illuminate\Support\Facades\Log;

class CargarDataSintesi implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    /**
     * Create a new job instance.
     */
    public function __construct()
    {
        //
    }

    /**
     * Execute the job.
     */
    public function handle(): void
    {

        ini_set('max_execution_time', 36000);

        $responseTodosLosClientesWispro = Helpers::obtenerTodosLosClienteWispro();
        Log::channel('cargaSintesis')->info("codigoC: " . $responseTodosLosClientesWispro);


        Log::channel('cargaSintesis')->info("Envio a Sintesis " . now());
        $contadorOK = 0;
        $contadorError = 0;
        for ($i = 1; $i < 55; $i++) {
            $responseTodosLosClientesWispro = Helpers::records_page($i, 20);

            $dataClientes = $responseTodosLosClientesWispro['data'];
            //return $dataClientes;
            Log::channel('cargaSintesis')->info('Cantidad de clientes::>' . count($dataClientes));
            sleep(2);
            foreach ($dataClientes as $cliente) {
                $obtenerPrecio = Helpers::obtenerPrecioDelContratoXClientId($cliente['id']); //probar

                $correoElectronico = $cliente['email'] == null ? '' : $cliente['email'];
                $documentoIdentidadComprador = $cliente['national_identification_number'];
                $nombreComprador = $cliente['name'];
                $codigoComprador = $cliente['custom_id'];
                $montoCreditoFiscal = 0;
                $montoPago = $obtenerPrecio;
                $nitFactura = $cliente['national_identification_number'];
                $nombreFactura = $cliente['name'];
                $codigoRecaudacion = $codigoComprador; //$codigoRecaudacion2;

                // $cont++;
                //guardar
                
                $registroAlta = Helpers::registraAlta(
                    $i,
                    $correoElectronico,
                    $documentoIdentidadComprador,
                    $nombreComprador,
                    $codigoComprador,
                    $montoCreditoFiscal,
                    $montoPago,
                    $nitFactura,
                    $nombreFactura,
                    $codigoRecaudacion
                );
                // $codigoRecaudacion2++;
                //return $registroAlta;
                if ($registroAlta['codigoError'] == 0) {
                    $contadorOK++;
                    Log::channel('cargaSintesis')->info($contadorOK . "- codigoC: " . $codigoComprador . " codigoError: " . $registroAlta['codigoError'] . " descripcion:
    " . $registroAlta['descripcionError']);
                    $idTransaccion = $registroAlta['idTransaccion'];
                    $registroItem = Helpers::registraItem($idTransaccion, $montoPago);
                    $new_sintesis = Sintesi::find($registroAlta['id']);
                    if ($registroItem['codigoError'] == 0) {

                        Log::channel('cargaSintesis')->info('CustomId:' . $codigoComprador . ':: Nombre:' . $nombreComprador);

                        $new_sintesis->idTransaccion = $idTransaccion;
                        $new_sintesis->codigoError = $registroAlta['codigoError'];
                        $new_sintesis->descripcionError = $registroAlta['descripcionError'];
                        $new_sintesis->codigoErrorItem = $registroItem['codigoError'];
                        $new_sintesis->descripcionErrorItem = $registroItem['descripcionError'];
                        $new_sintesis->update();
                    } else {
                        $message = 'Error al registrar el item';
                        Log::channel('cargaSintesis')->info('CustomId:' . $codigoComprador . ':: Nombre:' . $nombreComprador);
                        $new_sintesis->codigoErrorItem = $registroItem['codigoError'];
                        $new_sintesis->descripcionErrorItem = $registroItem['descripcionError'];

                        $new_sintesis->update();
                    }
                } else if ($registroAlta['codigoError'] == 1) {
                    $contadorError++;
                    Log::channel('cargaSintesis')->info($contadorError . "- codigoC: " . $codigoComprador . " codigoError: " . $registroAlta['codigoError'] . " descripcion:
    " . $registroAlta['descripcionError']);
                    // todo Guardar el error en la BD
                    $error_sintesis = new ErrorSintesi();
                    $error_sintesis->customId = $codigoComprador;
                    $error_sintesis->nombre = $nombreComprador;
                    $error_sintesis->ci = $documentoIdentidadComprador;
                    $error_sintesis->monto = $montoPago;
                    $error_sintesis->save();
                    $message = 'Error al cargar info en sintesis';
                    $update_sintesis = Sintesi::find($registroAlta['id']);
                    $update_sintesis->codigoError = $registroAlta['codigoError'];
                    $update_sintesis->descripcionError = $registroAlta['descripcionError'];
                    $update_sintesis->update();
                } else {
                    $contadorError++;
                    Log::channel('cargaSintesis')->info($contadorError . "- error");
                }
            }
            //$rec->cod_recaudacion = $codigoRecaudacion2;
            //$rec->update();
            Log::channel('cargaSintesis')->info('OK :::> 0' . $contadorOK);
            Log::channel('cargaSintesis')->info('error :::>' . $contadorError);
            Log::channel('cargaSintesis')->info('OK :::> 0' . $contadorOK . ' :::::::::::>');
            Log::channel('cargaSintesis')->info('error :::>' . $contadorError . ' :::::::::::>');
        }
    }
}
