<?php

namespace App\Jobs;

use App\Helpers\Helpers;
use App\Models\Sintesi;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldBeUnique;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;

class DeleteData implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    // public $sintesi;
    /**
     * Create a new job instance.
     */
    public function __construct()
    {
        //
        // $this->$sintesi = $sintesi;
    }

    /**
     * Execute the job.
     */
    public function handle(): void
    {
        //
        $sintesiCount = Sintesi::all()->count();
        $sintesiData=Sintesi::all();

        $sintesiData3 = [

            [
                "correoElectronico" => "",
                "documentoIdentidadComprador" => "5652951",
                "nombreComprador" => "Pablo Llacza Anagua",
                "codigoComprador" => "210012",
                "montoCreditoFiscal" => 0,
                "montoPago" => 100,
                "nitFactura" => "5652951",
                "nombreFactura" => "Pablo Llacza Anagua",
                "codigoRecaudacion" => "210012202402",

            ],
            [
                "correoElectronico" => "imprentagrafic.printer@gmail.com",
                "documentoIdentidadComprador" => "4852429",
                "nombreComprador" => "German Pillco",
                "codigoComprador" => "210088",
                "montoCreditoFiscal" => 0,
                "montoPago" => 100,
                "nitFactura" => "4852429",
                "nombreFactura" => "German Pillco",
                "codigoRecaudacion" => "210088202402",


            ]

        ];
        $contadorOK=0;
        $contadorError=0;
        foreach ($sintesiData as $data) {
            $registroBaja = Helpers::registraBaja(
                $data['correoElectronico'],
                $data['documentoIdentidadComprador'],
                $data['nombreComprador'],
                $data['codigoComprador'],
                $data['montoCreditoFiscal'],
                $data['montoPago'],
                $data['nitFactura'],
                $data['nombreFactura'],
                $data['codigoRecaudacion'],
            );
            // echo $registroBaja['codigoError']."<br>";
            // echo $registroBaja['descripcionError'].'<br>';
            // echo $registroBaja['idTransaccion'].'<br>';
            if ($registroBaja['codigoError'] == 0) {
                $contadorOK++;
                \Log::info($contadorOK."- codigoC: " . $data['codigoComprador'] . " codigoError: " . $registroBaja['codigoError'] . " descripcion:
" . $registroBaja['descripcionError']);
                // \Log::info();
                // \Log::info($registroBaja['idTransaccion']);
            } else if ($registroBaja['codigoError'] == 1) {
                $contadorError++;
                \Log::info($contadorError."- codigoC: " . $data['codigoComprador'] . " codigoError: " . $registroBaja['codigoError'] . " descripcion:
" . $registroBaja['descripcionError']);
                // \Log::info($registroBaja['descripcionError']);
            } else {
                $contadorError++;
                \Log::info($contadorError."- error");
            }
        }

       
    }
}