<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration {
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('users', function (Blueprint $table) {
            $table->id();
            $table->string('name');
            $table->string('email')->unique();
            //registrado 0 registro desde sistema admin
            //registrado 1 registro cliente con datos wispro
            $table->integer('registrado')->dafault(0);
            // estado 0 no tiene cuenta wispro
            // estado 1 si tiene cuenta wispro
            $table->integer('cuenta')->dafault(0);
            $table->integer('estado')->nullable();
            $table->timestamp('email_verified_at')->nullable();
            $table->string('password');
            $table->rememberToken();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('users');
    }
};