<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration {
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('facturas', function (Blueprint $table) {
            $table->id();
            $table->string('nombreCliente')->nullable();
            $table->string('custom_id')->nullable();
            // $table->string('cliente_uuid');
            $table->decimal('amount')->default(0.0)->nullable();
            $table->string('numeroFactura')->nullable();
            $table->string('periodo')->nullable();
            $table->integer('estado'); // 0= en proceso 1= pagado
            $table->integer('imprime'); // 0= imprime 1= No imprime

            // $table->string('stateFactura');
            // $table->string('product_code');
            // $table->dateTime('first_due_date')->nullable();
            // $table->dateTime('second_due_date');
            // Relacionamos con cliente
            // $table->bigInteger('client_id')->unsigned();
            // $table->foreign('client_id')->references('id')->on('clients');
            // Relacionamos con el Qr
            $table->bigInteger('imagen_qr_id')->unsigned();
            $table->foreign('imagen_qr_id')->references('id')->on('imagen_qrs')->onDelete('cascade');
            $table->bigInteger('client_id')->unsigned();
            $table->foreign('client_id')->references('id')->on('clients')->onDelete('cascade');

            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('facturas');
    }
};
