<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('lista_negras', function (Blueprint $table) {
            $table->id();
            $table->string("custom_id");
            $table->string("name");
            $table->decimal("precio", 10, 1)->nullable();
            $table->string("contrato_id");
            $table->string("plan_id");
            $table->string("client_id");
            $table->string("state_contrato")->nullable();
            $table->string("periodo");
            $table->string("pasarela"); // por QR Sintesis otro
            $table->dateTime("hora_salida_lista_negra")->nullable(); // hora de activacion em smart
            $table->dateTime("hora_activar_smart")->nullable(); // hora de activacion em smart
            $table->string("estado_smart")->nullable(); // estado despues de activar smart
            $table->string("descripcion")->nullable(); // Descripcion
            $table->integer("estado")->default(0); // 0= entra al cron pago 1=ya salio del cron 
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('lista_negras');
    }
};
