<?php

namespace App\Events;

use App\Models\Bnb;
use Illuminate\Broadcasting\Channel;
use Illuminate\Broadcasting\InteractsWithSockets;
use Illuminate\Broadcasting\PresenceChannel;
use Illuminate\Broadcasting\PrivateChannel;
use Illuminate\Contracts\Broadcasting\ShouldBroadcast;
use Illuminate\Foundation\Events\Dispatchable;
use Illuminate\Queue\SerializesModels;

class RegistrarPagoEvent
{
    use Dispatchable, InteractsWithSockets, SerializesModels;

    /**
     * Create a new event instance.
     */
    public Bnb $bnb;
    public function __construct($bnb)
    {
        $this->bnb = $bnb;
    }

    /**
     * Get the channels the event should broadcast on.
     *
     * @return array<int, \Illuminate\Broadcasting\Channel>
     */
    public function broadcastOn(): \Illuminate\Broadcasting\Channel|array
    {
        // return [
        //     new PrivateChannel('channel-name'),
        // ];
        return new PrivateChannel('channel-name');
    }
}