<?php

namespace App\Http\Controllers;

use App\Helpers\Helpers;
use App\Models\Bnb;
use App\Models\Client;
use App\Models\ImagenQr;
use App\Models\Factura;
use App\Models\Mensaje;
use App\Models\Mespagado;
use App\Models\Pago;
use App\Models\PagoAdelantado;
use App\Models\PagoWispro;
use App\Models\Plan;
use App\Models\Qr;
use App\Models\User;
use App\Models\Wisprocron;
use Carbon\Carbon;
use DateTime;
use DateTimeZone;
use Illuminate\Http\Request;
use Illuminate\Support\Arr;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Http;
use Str;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;
use stdClass;

class WisproController extends Controller
{
    //
    public function lista_clientes_paginado_busqueda_nombres(Request $request)
    {

        //http://api.laravel.com/api/v1/producto?page=1&q=tec&limit=5
        try {
            $limit = isset($request->limit) ? $request->limit : 5;
            if ($request->q) {
                // $usuarios = User::where('name', 'like', "%" . $request->q . "%")
                //     ->orderBy('id', 'desc')
                //     ->paginate($limit);
                $response = Http::withHeaders([
                    'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
                    'accept' => 'application/json',

                ])->get('https://www.cloud.wispro.co/api/v1/clients');
            } else {
                // $usuarios = User::orderBy('id', 'desc')->paginate($limit);
                $response = Http::withHeaders([
                    'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
                    'accept' => 'application/json',

                ])->get('https://www.cloud.wispro.co/api/v1/clients', [
                    'per_page' => $request->limit,
                    // 'issued_at_after' => '2023-05-30T00:00:11.919-05:00',
                    'page' => $request->page,
                    //     'client_custom_id_eq' => '',
                    //     'state_eq' => ''
                ]);
            }
            // return response()->json($usuarios, 200);

            $datos = json_decode($response);
            // $datos2 = $datos->data;
            $datos2 = $datos;
            return response()->json($datos2, 200);
        } catch (\Exception $e) {
            return response()->json([
                'success' => false,
                'message' => 'Hubo un error en la consulta::>' . $e
            ], 200);
        }
    }
    public function lista_clientes(Request $request)
    {

        //http://api.laravel.com/api/v1/producto?page=1&q=tec&limit=5
        try {
            $limit = isset($request->limit) ? $request->limit : 100;
            if (isset($request->q)) {
                // $usuarios = User::where('name', 'like', "%" . $request->q . "%")
                //     ->orderBy('id', 'desc')
                //     ->paginate($limit);
                $response = Http::withHeaders([
                    'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
                    'accept' => 'application/json',

                ])->get('https://www.cloud.wispro.co/api/v1/clients?' . $request->q);
            } else {
                // $usuarios = User::orderBy('id', 'desc')->paginate($limit);
                $response = Http::withHeaders([
                    'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
                    'accept' => 'application/json',

                ])->get('https://www.cloud.wispro.co/api/v1/clients', [
                    'per_page' => $request->limit,
                    // 'issued_at_after' => '2023-05-30T00:00:11.919-05:00',
                    'page' => $request->page,
                    //     'client_custom_id_eq' => '',
                    //     'state_eq' => ''
                ]);
            }
            // return response()->json($usuarios, 200);

            $datos = json_decode($response);
            // $datos2 = $datos->data;
            $datos2 = $datos;
            return response()->json($datos2, 200);
        } catch (\Exception $e) {
            return response()->json([
                'success' => false,
                'message' => 'Hubo un error en la consulta::>' . $e
            ], 200);
        }
    }
    public function lista_pagos_clientes(Request $request)
    {
        $pagos = Pago::orderBy('id', 'desc')->paginate(200);


        return response()->json($pagos, 200);
    }
    public function lista_contratos_deshabilitados(Request $request)
    {
        $pagos = Wisprocron::orderBy('id', 'desc')->paginate(1000);


        return response()->json($pagos, 200);
    }
    public function actualiza_estado_cliente_smart(Request $request)
    {
        //obtenemos clientes
        $responseClient = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',
            //https://www.cloud.wispro.co/api/v1/clients?page=1&per_page=1000
        ])->get('https://www.cloud.wispro.co/api/v1/clients?page=' . $request->page . '&per_page=' . $request->limit);
        $clientes = json_decode($responseClient, true);
        //Obtenemos COntratos
        //https://www.cloud.wispro.co/api/v1/contracts?page=1&per_page=1000
        $responseContratos = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',
            //https://www.cloud.wispro.co/api/v1/clients?page=1&per_page=1000
        ])->get('https://www.cloud.wispro.co/api/v1/contracts?page=' . $request->page . '&per_page=' . $request->limit);
        $contratos = json_decode($responseContratos, true);
        $contratos = $contratos['data'];
        $clientes = $clientes['data'];
        $cont = 0;
        $cont2 = 0;
        $listDisabled = [];
        $listEnabled = [];
        $aux = [];
        $au2 = [];
        $idsContratos = [];
        foreach ($clientes as $client) {
            //     //  echo ' visited ' . $country['id'] . ' in ' . $country['invoice_number'] . 'P.\n';

            $cont++;

            foreach ($contratos as $contrato) {
                if ($client['id'] == $contrato['client_id']) {
                    $contrato['state'];
                    $cont2++;
                    if ($contrato['state'] == 'disabled') {
                        // echo "catTv esta : " . $montoTotal;
                        // echo "<br>";
                        // echo $customID;
                        // $resp = Helpers::deshabilitar_cattv($client['custom_id']);
                        $listDisabled[] = $contrato['state'];
                        array_push($aux, [
                            'custom_id' => $client['custom_id'],
                            'id' => $client['id'],
                            'data' => $contrato
                        ]);
                        break;
                    } elseif ($contrato['state'] == 'enabled') {
                        // $resp = Helpers::habilitar_cattv($client['custom_id']);

                        $listEnabled[] = $contrato['state'];
                        array_push($aux, [
                            'custom_id' => $client['custom_id'],
                            'id' => $client['id'],
                            'data' => $contrato
                        ]);
                        break;
                    }
                } else {
                    $idsContratos[] = $contrato['client_id'];
                    /*
                    array_push($aux2, [
                        'custom_id' => $client['custom_id'],
                        //'id' => $client['id'],
                        //  'contrato' => $contrato['client_id']
                    ]);*/
                }
            }
        }

        return response()->json([
            'cont' => $cont,
            'cont2' => $cont2,
            // 'listDisabled' => $listDisabled,
            // 'listEnabled' => $listEnabled,
            // 'listDisabledCont' => count($listDisabled),
            // 'listEnabledCont' => count($listEnabled),
            'aux' => $aux,
            'ids' => $idsContratos,
            //'aux2' => $aux2,
            // 'cant' => count($ids_clientes),
            //'idsClientes' => $ids_clientes,
            // 'idsContratos' => $ids_contratos,
        ], 200);
        //return response()->json($contratos['data'], 200);
    }
    public static function bucarCliente(Request $request)
    {

        //
        //*************funca***************** */
        //https://www.cloud.wispro.co/api/v1/clients?name_unaccent_cont=&custom_id_eq=&phone_number_cont=76760697&national_identification_number_eq=
        $customId = is_numeric($request->q);
        if (is_numeric($request->q)) {
            $token4 = 'https://www.cloud.wispro.co/api/v1/clients?national_identification_number_eq=' . $request->q;
        } else {
            $token4 = 'https://www.cloud.wispro.co/api/v1/clients?name_unaccent_cont=' . $request->q; //.'&custom_id_eq='.$request->q;    

        }
        $nombre = is_string($request->q);

        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($token4);

        $datos = json_decode($response, true);
        return $datos; //()->json($datos, 200);
    }
    public function obtener_facturas(Request $request)
    {
        //
        //*************funca***************** */

        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get('https://www.cloud.wispro.co/api/v1/invoicing/invoices', [
            'per_page' => $request->limit,
            // 'issued_at_after' => '2023-05-30T00:00:11.919-05:00',
            'page' => $request->page,
            // 'per_page' => 100,
            // // 'issued_at_after' => '2023-05-30T00:00:11.919-05:00',
            // 'page' => 190,
            // 'client_custom_id_eq' => '',
            // 'state_eq' => ''
        ]);

        $datos = json_decode($response);
        // $datos2 = $datos->data;
        $datos2 = $datos;
        //dd($datos2);

        return response()->json($datos2, 200);

        //*************fin funca************* */
    }

    public function obtenerFacturasXCarnet($id)
    {
        $facturasPendientes = Helpers::obtenerFacturasXCI($id);


        return response()->json($facturasPendientes);
    }
    public function infoDashboard()
    {

        $mes = Helpers::obtenerMesActual();
        $totalClientesWispro = Helpers::obtenerTodosLosClienteWispro();
        $user = User::where('cuenta', '=', 0)->get()->all();
        $totalUsuarios = count($user);

        $totalCobradoPorQr = ImagenQr::where('estado', '=', 1)->sum('montoMes');
        $cantidadQrPagados = Bnb::all();
        $cantidadQrPagados = count($cantidadQrPagados);


        return response()->json([
            'success' => true,
            'totalClientes' => $totalClientesWispro,
            'totalRecaudado' => $totalCobradoPorQr,
            'cantidadQrsPagados' => $cantidadQrPagados,
            'totalUsuarios' => $totalUsuarios,
            'mes' => $mes,
            'usuarios' => $user,
        ], 200);
    }
    public function verificacion()
    {




        return response()->json([
            'success' => true,

        ], 200);
    }
    public function verificacion2($qrId, Request $request)
    {


        // $qrr = Qr::where("qr_id", $qrId)->count();
        // if ($qrr > 0) {

        //     return $qrr;
        // } else {
        //     return 'error';
        // }
        $qrr = Qr::where("qr_id", $qrId)->first();
        $clientID = $qrr->client_id;
        $client = Client::where("id", $clientID)->first();
        $clienteNroCi = $client->national_identification_number;
        return $clienteNroCi;
        $facturasPendientes = Helpers::facturasPendientes($qrId);
        $facturasPendientes = $facturasPendientes['meta'];
        $facturasPendientes = $facturasPendientes['pagination'];
        $factPendientes = $facturasPendientes['total_records'];
        return $factPendientes;
        $authBnb = Helpers::tokenAuthBnb();
        $success = $authBnb['success'];
        $tokenBnb = $authBnb['message'];
        $statusQrBnb = Helpers::statusQrBnb($tokenBnb, $qrId);
        return $statusQrBnb;
        if ($success) {
            $statusQrBnb = Helpers::statusQrBnb($tokenBnb, $qrId);
            $statusId = $statusQrBnb['statusId'];
            return $statusId;
        } else {
            return 'error';
        }




        return response()->json([
            'success' => true,

        ], 200);
    }
    public function facturas_pendientes_pago($nro_ci)
    {

        date_default_timezone_set('America/La_Paz');
        $caso = 0;
        try {
            //Nro de contratos
            // $id_client_wispro = Helpers::obtenerClienteId($id);        //
            // $contratosIdXClientes = Helpers::cantContratosClientexId($id_client_wispro[0]);
            //***$contratosIdXClientes= contrato_id,plan_id,client_id

            $contratosIdXClientes = Helpers::cantContratosClientexId($nro_ci);
            $facturasPendientes = Helpers::facturasPendientes($nro_ci);
            $facturasPendientes = $facturasPendientes['data'];

            // return response()->json($facturasPendientes[0]['contract_id']);//$factura['contract_id']

            $resumen = [];
            $precio = 0;
            $client_id = '';


            $fechaActual = date('Y-m');
            foreach ($contratosIdXClientes as $contrato) {
                $precio = Helpers::obtenerPlanXContratoId($contrato['plan_id']);
                $cliente_titular_del_contratos = Helpers::obtenerClienteXUuid($contrato['client_id']);
                $amount = floatval($precio);
                $client_id = Client::where('custom_id', $cliente_titular_del_contratos['custom_id'])->first();
                $resumen[] = [
                    'contratoId' => $contrato['contratoId'],
                    //'nombrePlan' => $precio['nombre'], 
                    'precioPlan' => $amount,
                    'custom_id' => $cliente_titular_del_contratos['custom_id'],
                    'client_id' => $client_id->id,
                    'name' => $cliente_titular_del_contratos['name']
                ];
                //$precio = 0;
            }
            if (count($facturasPendientes) == 0) {
                $mensaje4 = Mensaje::find(5);
                $caso = 0;
                $expirationDate = date('Y-m');
                $expirationDate = date("Y-m", strtotime($expirationDate . "+ 1 month"));
                return response()->json([
                    'nroCaso' => $caso,
                    //'custom_id' => $nro_ci,
                    //'id_client_wispro' => $id_client_wispro,
                    'cantFacturas' => count($facturasPendientes),

                    'fechaPago' => $expirationDate,
                    'mensaje' => $mensaje4->mensaje,
                    'client_id' => $client_id,
                    'resumen' => $resumen
                ], 200);
            }

            // return response()->json($resumen);


            // return response()->json($resumen, 200);

            // return response()->json($id_client_wispro);
            // return response()->json(count($facturasPendientes));
            $aux = [];
            $auxFinal = [];
            $auxFinal2 = [];
            $idsFacturasPago = [];
            $idsFacturasPagoMesActual = [];
            $idsPago = [];
            $cont = 0;
            $fechaActual = date('m-Y');
            $fecha = '';
            $fechaMes = '';
            $idsFacturasPagoFechaUltimoMes = '';
            $product_code = '';
            $description_product = '';
            $amount = '';
            $numeroFactura = '';
            $cliente_uuid = '';
            $client_id = '';
            // return response()->json($facturasPendientes);
            for ($i = 0; $i < count($contratosIdXClientes); $i++) {


                foreach ($facturasPendientes as $factura) {

                    if ($contratosIdXClientes[$i]['contratoId'] == $factura['contract_id']) {
                        $cont++;
                        $fechaComoEntero = strtotime($factura['issued_at']);
                        $anio = date("m-Y", $fechaComoEntero);
                        if ($fechaActual == $anio) {
                            $fecha = $anio;
                            $idsFacturasPagoFechaUltimoMes = $anio;
                            $idsFacturasPagoMesActual[] = [$factura['id'], $factura['invoice_number'], $factura['issued_at'], $factura['amount']];
                            $numeroFactura = $factura['invoice_number'];
                            $mont = floatval($factura['amount']);
                            $amount = floatval($factura['amount']);
                            $description_product = $factura['items'][0]['description'];
                            $product_code = $factura['items'][0]['product_code'];
                            $cliente_uuid = $contratosIdXClientes[$i]['client_id'];
                        }

                        $idsFacturasPago[] = [$factura['id'], $factura['invoice_number'], $factura['from'], $factura['amount']];
                        $idsPago[] = [
                            'id' => $factura['id'],
                            'invoice_number' => $factura['invoice_number'],
                            'amount' => $factura['amount']
                        ];


                        array_push($aux, $factura);
                        $mont = floatval($factura['amount']);
                        // echo "entro";
                        // $mont = floatval($facturasPendientes[$i]['amount']);
                    }
                    //  $facturaissued_at=$factura['issued_at'];



                }

                if ($cont > 3) {
                    $mensaje3 = Mensaje::find(3);
                    $caso = 4;
                    // $mont = floatval($resumen[$i]['precioPlan']);
                    $mont = floatval($facturasPendientes[$i]['amount']);
                    $auxFinal2[] = [
                        //'contratoID' => $contratosIdXClientes[$i],
                        'contratoIDResumen' => $resumen[$i]['contratoId'],
                        //'cliente' => $id_client_wispro[1],
                        // 'customID' => $id,
                        'nroCaso' => $caso,
                        'cantFacturas' => $cont,
                        // 'nomPlan' => $resumen[$i]['nombrePlan'],
                        'precioPlan' => $resumen[$i]['precioPlan'],
                        'nombreCliente' => $resumen[$i]['name'],
                        'custom_id' => $resumen[$i]['custom_id'],
                        //'fecha' => $fecha,
                        //'monto' => number_format($facturasPendientes[$i]['amount'], 1),
                        // 'monto' => $mont,
                        'mensaje' => $mensaje3->mensaje,
                        //'idsFacturasPago' => $idsFacturasPago,
                        //'facturas' => $aux
                    ];
                } elseif ($cont > 0) {
                    $auxFinal[] = [
                        // 'contratoID' => $contratosIdXClientes[$i],
                        'contratoIDResumen' => $resumen[$i]['contratoId'],
                        // 'customID' => $id,
                        //'cliente' => $id_client_wispro[1],
                        //'nombrePlan' => $resumen[$i]['nombrePlan'],
                        //'nomPlan' => $resumen[$i]['nombrePlan'],
                        'precioPlan' => $resumen[$i]['precioPlan'],
                        'nombreCliente' => $resumen[$i]['name'],
                        'custom_id' => $resumen[$i]['custom_id'],
                        'client_id' => $resumen[$i]['client_id'],
                        'cantidad' => $cont,
                        'description_product' => $description_product,
                        'product_code' => $product_code,
                        // 'facturaissued_at' => $facturaissued_at,
                        // 'fechaMes' => $fechaMes,
                        'anio' => $anio,
                        'fecha' => $fecha,
                        'monto' => $amount,
                        'montoResumen' => $resumen[$i]['precioPlan'],
                        'mensaje' => 'Sr.cliente comuniquese con la empresa',
                        'idsFacturasPagoMesActual' => $idsFacturasPagoMesActual,
                        'idsFacturasPago' => $idsFacturasPago,
                        'facturas' => $aux,
                        'paraPagar' => [
                            'nombreCliente' => $resumen[$i]['name'],
                            'custom_id' => $resumen[$i]['custom_id'],
                            'cliente_uuid' => $contratosIdXClientes[$i]['client_id'],
                            'client_id' => $resumen[$i]['client_id'],
                            'monto' => $amount,
                            'numeroFactura' => $numeroFactura,
                            'fecha' => $fecha,
                            'idsPago' => $idsPago,

                        ]
                    ];
                }
                $aux = [];
                $idsFacturasPago = [];
                $idsFacturasPagoMesActual = [];
                $idsPago = [];
                $idsFacturasPagoFechaUltimoMes = '';
                $cont = 0;
                $fecha = '';
                $amount = '';
                $description_product = '';
                $product_code = '';
            }

            return response()->json([
                'status' => true,
                'dataPendientes' => $auxFinal2,
                'data' => $auxFinal
            ], 200);
        } catch (\Exception $e) {
            return response()->json([
                "status" => false,
                "mensaje" => "Error al obtener facturas pendientes.",
            ], 422);
        }


        foreach ($contratosIdXClientes as $contratoId) {
            echo $contratoId['id'];
            echo "<br>";
            /*
            foreach ($facturasPendientes as $factura) {
                if ($contratoId['id'] == $factura['id']) {
                    $cont++;
                    array_push($aux, $factura);
                }
            }*/
        }
        // return response()->json($aux);
        $datos2 = $datos;
        // mas de 3 facturas
        $meta = $datos2['meta'];
        $pagination = $meta['pagination'];
        $cantFacturas = $pagination['total_records'];

        if ($cantFacturas > 3) {
            $mensaje3 = Mensaje::find(3);
            $caso = 1;
            return response()->json([
                'success' => true,
                'nroCaso' => $caso,
                'cantFacturas' => $cantFacturas,
                'mensaje' => $mensaje3->mensaje,
            ], 200);
        }
        return response()->json([
            'nroCaso' => $caso,
            'success' => false,
            'cantFacturas' => $cantFacturas,
            'mensaje' => $datos2,

        ], 422);
        $soloData = $datos2['data'];

        $fechaActual = date('Y-m');
        // $fechaActual2 = '2023-06-09';





        $facturaFechaActual = '';
        $ids_facturas_pagarActual = '';
        $amountMesActual = [];
        // $nroFacturaActual = '';
        $nroFacturaActual = '';
        $estadoFacturaActual = '';
        $montoTotalActual = 0;

        $facturaFechaMesAnterior = [];
        $ids_facturas_a_pagarMes = [];
        $amountMesAnterior = [];
        $nroFacturaAnterior = [];
        $estadoFacturaAnterior = [];
        $montoTotalMesAnterior = 0;

        $auxFechaAutual = [];
        $auxFechaAnterior = [];

        foreach ($soloData as $data) {
            $fechaComoEntero = strtotime($data['issued_at']);
            $anio = date("Y-m", $fechaComoEntero);

            if ($fechaActual == $anio) {
                array_push($auxFechaAutual, $data);
                $facturaFechaActual = $data['issued_at'];
                $ids_facturas_pagarActual = $data['id'];
                $nroFacturaActual = $data['invoice_number'];
                $estadoFacturaActual = $data['state'];
                $amountMesActual[] = $data['amount'];
                $montoTotalActual = $montoTotalActual + $data['amount'];
            } else {
                array_push($auxFechaAnterior, $data);
                $facturaFechaMesAnterior[] = $data['issued_at'];
                $ids_facturas_a_pagarMes[] = $data['id'];
                $nroFacturaAnterior[] = $data['invoice_number'];
                $estadoFacturaAnterior[] = $data['state'];
                $amountMesAnterior[] = $data['amount'];
                $montoTotalMesAnterior = $montoTotalMesAnterior + $data['amount'];
            }
        }
        //para obtener el id_wispro
        $client = Client::select('id', 'id_wispro', 'name', 'email', 'custom_id')->where("custom_id", $id)->get();
        // dd(count($client));
        if (count($client) == 0) {

            $usuario = Auth::user();
            $ruta = 'clients?custom_id_eq=';
            $cliente2 = Helpers::obtenerCustomIdClientWispro($ruta, $id);
            $cli2 = $cliente2['data'];
            if (count($cli2) == 0) {
                $mensaje7 = Mensaje::find(7);
                $caso = 2;
                return response()->json([
                    'success' => true,
                    'nroCaso' => $caso,
                    'mensaje' => $mensaje7->mensaje,

                ], 200);
            }
            $cli = $cli2[0];
            $id_wispro = $cli['id'];
            $nombreCliente = $cli['name'];
            $emailCliente = $cli['email'];
            $codCliente = $cli['custom_id'];
            $idCliente = $usuario->id;
        } else {

            $id_wispro = $client[0]->id_wispro;
            $nombreCliente = $client[0]->name;
            $emailCliente = $client[0]->email;
            $codCliente = $client[0]->custom_id;
            $idCliente = $client[0]->id;
        }

        //obtenemos el contrato
        $plan_id = Helpers::obtenerPlanWispro($id_wispro);

        //obtnemos al plan registrado
        $plan2 = Helpers::obtenerPlan($plan_id);
        $plan_nombre = $plan2['name'];
        $plan_precio = $plan2['price'];
        //generar QR
        // obtener token
        $response_token = Helpers::tokenAuthBnb();
        $success = $response_token['success'];
        $fechaActual = date('d-m-Y');
        if ($success) {
            $token = $response_token['message'];
            $fech = date('m-Y');
            $gloss = 'Servicio ' . $fech . ' Cod Cli ' . $id . ' F-' . $nroFacturaActual;
            $singleUse = true;
            $expirationDate = date('Y-m-d');
            $expirationDate = date("Y-m-d", strtotime($expirationDate . "+ 1 days"));
            $hoy = date('Y-m-d H:i:s');


            $additionalData = 'Qr. generado en fecha ' . $hoy;
            $qr = Helpers::generarQrBnb($token, $gloss, $plan_precio, $singleUse, $expirationDate, $additionalData, $idCliente);

            if ($qr['success']) {

                $qr2_id = Qr::select('id')->where("id", $idCliente)->get();
                $qr_id2 = $qr2_id[0]->id;
                $qrnew = new ImagenQr();
                $qrnew->qrId = $qr['id'];
                $qrnew->imageQr = $qr['qr'];
                $qrnew->numeroFactura = $nroFacturaActual;
                $qrnew->customID = $codCliente;
                $qrnew->id_wispro = $id_wispro;
                $qrnew->state = $estadoFacturaActual;
                $qrnew->idfactura = $ids_facturas_pagarActual;
                $qrnew->qr_id = $qr_id2;

                $qrnew->save();
                // if (count($ids_facturas_pagarActual) > 0 || count($ids_facturas_a_pagarMes) > 0) {
                if ($ids_facturas_pagarActual != '' || count($ids_facturas_a_pagarMes) > 0) {
                    $mensaje8 = Mensaje::find(8);
                    $caso = 3;
                    return response()->json([
                        'nroCaso' => $caso,
                        // 'cantFacActual' => count($ids_facturas_pagarActual),
                        // 'cantFacAnterior' => count($ids_facturas_a_pagarMes),
                        // 'nroFacturaActual' => $nroFacturaActual,
                        // 'nroFacturaAnterior' => $nroFacturaAnterior,
                        // 'idsFacturaActual' => $ids_facturas_pagarActual,
                        // 'idsFacturaAnterior' => $ids_facturas_a_pagarMes,
                        // 'fechaFacturaActual' => $facturaFechaActual,
                        // 'fechaFacturaAnterior' => $facturaFechaMesAnterior,
                        // 'estadoFacturaActual' => $estadoFacturaActual,
                        // 'estadoFacturaAnterior' => $estadoFacturaAnterior,
                        // 'montoMesActual' => $amountMesActual,
                        // 'montoMesAnterior' => $amountMesAnterior,
                        // 'montoTotalMesActual' => $montoTotalActual,
                        // 'montoTotalMesAnterior' => $montoTotalMesAnterior,
                        'data' => $auxFechaAutual,
                        'nombreCliente' => $nombreCliente,
                        'emailCliente' => $emailCliente,
                        'codCliente' => $codCliente,
                        'fechaActual' => $fechaActual,
                        'plan_nombre' => $plan_nombre,
                        'plan_precio' => $plan_precio,
                        'mensaje' => $mensaje8->mensaje,
                        'qrnew' => $qrnew,
                        'qr' => $qr['qr'],
                        //'data' => $data
                    ], 200);
                } else {
                    $mensaje5 = Mensaje::find(5);
                    $caso = 4;
                    return response()->json([
                        'nroCaso' => $caso,
                        'nombreCliente' => $nombreCliente,
                        'emailCliente' => $emailCliente,
                        'codCliente' => $codCliente,
                        'fechaActual' => $fechaActual,
                        'plan_nombre' => $plan_nombre,
                        'plan_precio' => $plan_precio,
                        'mensaje' => $mensaje5->mensaje,
                        'qrnew' => $qrnew,
                        'qr' => $qr['qr'],
                    ], 200);
                }
                // if (count($ids_facturas_pagarActual) > 0 || count($ids_facturas_a_pagarMes) > 0) {
                if ($ids_facturas_pagarActual != '' || count($ids_facturas_a_pagarMes) > 0) {
                    $mensaje8 = Mensaje::find(8);
                    $caso = 3;
                    return response()->json([
                        'nroCaso' => $caso,
                        // 'cantFacActual' => count($ids_facturas_pagarActual),
                        // 'cantFacAnterior' => count($ids_facturas_a_pagarMes),
                        // 'nroFacturaActual' => $nroFacturaActual,
                        // 'nroFacturaAnterior' => $nroFacturaAnterior,
                        // 'idsFacturaActual' => $ids_facturas_pagarActual,
                        // 'idsFacturaAnterior' => $ids_facturas_a_pagarMes,
                        // 'fechaFacturaActual' => $facturaFechaActual,
                        // 'fechaFacturaAnterior' => $facturaFechaMesAnterior,
                        // 'estadoFacturaActual' => $estadoFacturaActual,
                        // 'estadoFacturaAnterior' => $estadoFacturaAnterior,
                        // 'montoMesActual' => $amountMesActual,
                        // 'montoMesAnterior' => $amountMesAnterior,
                        // 'montoTotalMesActual' => $montoTotalActual,
                        // 'montoTotalMesAnterior' => $montoTotalMesAnterior,
                        // 'data' => $aux,
                        'data' => $auxFechaAutual,
                        'nombreCliente' => $nombreCliente,
                        'emailCliente' => $emailCliente,
                        'codCliente' => $codCliente,
                        'fechaActual' => $fechaActual,
                        'plan_nombre' => $plan_nombre,
                        'plan_precio' => $plan_precio,
                        'mensaje' => $mensaje8->mensaje,

                        'qr' => $qr['qr'],
                        //'data' => $data
                    ], 200);
                } else {
                    $mensaje5 = Mensaje::find(5);
                    $caso = 4;
                    return response()->json([
                        'nroCaso' => $caso,
                        'nombreCliente' => $nombreCliente,
                        'emailCliente' => $emailCliente,
                        'codCliente' => $codCliente,
                        'fechaActual' => $fechaActual,
                        'plan_nombre' => $plan_nombre,
                        'plan_precio' => $plan_precio,
                        'mensaje' => $mensaje5->mensaje,
                        'qr' => $qr['qr'],
                    ], 200);
                }
            } else {
                return response()->json([
                    'success' => false,
                    'success' => false,
                    'message' => $qr['message'],
                ], 422);
            }
        } else {
            $mensaje6 = Mensaje::find(6);
            return response()->json([
                'nroCaso' => $caso,
                'success' => false,
                'mensaje' => $mensaje6->mensaje,

            ], 422);
        }








        //*************fin funca************* */
    }
    public function facturas_pendientes_pago_por_customID($customID, Request $request)
    {
        $todos_los_datos = $request->all();
        // return $todos_los_datos['id_wispro'];
        date_default_timezone_set('America/La_Paz');
        $caso = 0;
        //try {
        //Nro de contratos
        // $id_client_wispro = Helpers::obtenerClienteId($id);        //
        // $contratosIdXClientes = Helpers::cantContratosClientexId($id_client_wispro[0]);
        //***$contratosIdXClientes= contrato_id,plan_id,client_id

        $contratosIdXClientes = Helpers::obtenerEstadoDelContratosXuuid($todos_los_datos['id_wispro']);
        $facturasPendientes = Helpers::facturasPendientesPorCustomID($customID);
        $facturasPendientes = $facturasPendientes['data'];

        // return response()->json($facturasPendientes[0]['contract_id']);//$factura['contract_id']

        $resumen = [];
        $precio = 0;
        $client_id = '';


        $fechaActual = date('Y-m');
        // foreach ($contratosIdXClientes as $contrato) {
        $precio = Helpers::obtenerPlanXContratoId($contratosIdXClientes['plan_id']);

        $cliente_titular_del_contratos = Helpers::obtenerClienteXUuid($todos_los_datos['id_wispro']);
        $amount = floatval($precio);
        $client_id = Client::where('custom_id', $cliente_titular_del_contratos['custom_id'])->first();
        $resumen[] = [
            //'contratoId' => $contrato['contratoId'],
            //'nombrePlan' => $precio['nombre'], 
            'precioPlan' => $amount,
            'custom_id' => $cliente_titular_del_contratos['custom_id'],
            'client_id' => $client_id->id,
            'name' => $cliente_titular_del_contratos['name']
        ];

        //$precio = 0;
        //}
        if (count($facturasPendientes) == 0) {
            $mensaje4 = Mensaje::find(5);
            $caso = 0;
            $expirationDate = date('Y-m');
            $expirationDate = date("Y-m", strtotime($expirationDate . "+ 1 month"));
            return response()->json([
                'status' => true,

                'data' => [
                    'nroCaso' => $caso,
                    'cantFacturas' => count($facturasPendientes),
                    'fechaPago' => $expirationDate,
                    'mensaje' => $mensaje4->mensaje,
                    'client_id' => $client_id,

                ],

                //'custom_id' => $nro_ci,
                //'id_client_wispro' => $id_client_wispro,

            ], 200);
        }

        // return response()->json($resumen);


        // return response()->json($resumen, 200);

        // return response()->json($id_client_wispro);
        // return response()->json(count($facturasPendientes));
        $aux = [];
        $auxFinal = [];
        $auxFinal2 = [];
        $idsFacturasPago = [];
        $idsFacturasPagoMesActual = [];
        $idsPago = [];
        $cont = 0;
        $fechaActual = date('m-Y');
        $fecha = '';
        $fechaMes = '';
        $idsFacturasPagoFechaUltimoMes = '';
        $product_code = '';
        $description_product = '';
        $amount = '';
        $numeroFactura = '';
        $cliente_uuid = '';
        $client_id = '';
        $totalFcatura = 0;
        // return response()->json($facturasPendientes);



        foreach ($facturasPendientes as $factura) {


            $cont++;
            $fechaComoEntero = strtotime($factura['issued_at']);
            $anio = date("m-Y", $fechaComoEntero);
            if ($fechaActual == $anio) {
                $fecha = $anio;
                $idsFacturasPagoFechaUltimoMes = $anio;
                $idsFacturasPagoMesActual[] = [$factura['id'], $factura['invoice_number'], $factura['issued_at'], $factura['amount']];
                $numeroFactura = $factura['invoice_number'];
                $mont = floatval($factura['amount']);
                $amount = floatval($factura['amount']);
                $description_product = $factura['items'][0]['description'];
                $product_code = $factura['items'][0]['product_code'];
                // $cliente_uuid = $contratosIdXClientes['client_id'];
                $totalFcatura = $totalFcatura + floatval($factura['amount']);
            }
            $idsFacturasPago[] = [$factura['id'], $factura['invoice_number'], $factura['from'], $factura['amount']];
            $idsPago[] = [
                'id' => $factura['id'],
                'invoice_number' => $factura['invoice_number'],
                'amount' => $factura['amount']
            ];


            array_push($aux, $factura);
            $mont = floatval($factura['amount']);
            // echo "entro";
            // $mont = floatval($facturasPendientes[$i]['amount']);

            //  $facturaissued_at=$factura['issued_at'];



        }

        if ($cont > 3) {
            $mensaje3 = Mensaje::find(3);
            $caso = 4;
            // $mont = floatval($resumen[$i]['precioPlan']);
            $mont = floatval($factura['amount']);
            $auxFinal2[] = [
                //'contratoID' => $contratosIdXClientes[$i],
                // 'contratoIDResumen' => $resumen[$i]['contratoId'],
                //'cliente' => $id_client_wispro[1],
                // 'customID' => $id,
                'nroCaso' => $caso,
                'cantFacturas' => $cont,
                // 'nomPlan' => $resumen[$i]['nombrePlan'],
                'precioPlan' => $resumen['precioPlan'],
                'nombreCliente' => $resumen['name'],
                'custom_id' => $resumen['custom_id'],
                //'fecha' => $fecha,
                //'monto' => number_format($facturasPendientes[$i]['amount'], 1),
                // 'monto' => $mont,
                'mensaje' => $mensaje3->mensaje,
                //'idsFacturasPago' => $idsFacturasPago,
                //'facturas' => $aux
            ];
        } elseif ($cont > 0) {
            $caso = 6;
            $auxFinal = [
                // 'contratoID' => $contratosIdXClientes[$i],
                // 'contratoIDResumen' => $resumen[$i]['contratoId'],
                // 'customID' => $id,
                //'cliente' => $id_client_wispro[1],
                //'nombrePlan' => $resumen[$i]['nombrePlan'],
                //'nomPlan' => $resumen[$i]['nombrePlan'],
                'nroCaso' => $caso,
                'precioPlan' => $resumen[0]['precioPlan'],
                'nombreCliente' => $resumen[0]['name'],
                'custom_id' => $resumen[0]['custom_id'],
                'client_id' => $resumen[0]['client_id'],
                'cantidad' => $cont,
                'description_product' => $description_product,
                'product_code' => $product_code,
                'totalFcatura' => $totalFcatura,
                // 'facturaissued_at' => $facturaissued_at,
                // 'fechaMes' => $fechaMes,
                'cliente_uuid' => $todos_los_datos['id_wispro'],

                'anio' => $anio,
                'fecha' => $fecha,
                'monto' => $amount,
                'numeroFactura' => $numeroFactura,
                'montoResumen' => $resumen[0]['precioPlan'],
                'mensaje' => 'Sr.cliente comuniquese con la empresa',
                'idsFacturasPagoMesActual' => $idsFacturasPagoMesActual,
                'idsFacturasPago' => $idsFacturasPago,
                'facturas' => $aux,
                'paraPagar' => [
                    'nombreCliente' => $resumen[0]['name'],
                    'custom_id' => $resumen[0]['custom_id'],
                    'cliente_uuid' => $todos_los_datos['id_wispro'],
                    'client_id' => $resumen[0]['client_id'],
                    'monto' => $amount,
                    'numeroFactura' => $numeroFactura,
                    'fecha' => $fecha,
                    'idsPago' => $idsPago,

                ]
            ];
        }
        // $aux = [];
        // $idsFacturasPago = [];
        // $idsFacturasPagoMesActual = [];
        // $idsPago = [];
        // $idsFacturasPagoFechaUltimoMes = '';
        // $cont = 0;
        // $fecha = '';
        // $amount = '';
        // $description_product = '';
        // $product_code = '';


        return response()->json([
            'status' => true,
            'dataPendientes' => $auxFinal2,
            'data' => $auxFinal
        ], 200);
        /*
        } catch (\Exception $e) {
            return response()->json([
                "status" => false,
                "mensaje" => "Error al obtener facturas pendientes.",
            ], 422);
        }
        */


        foreach ($contratosIdXClientes as $contratoId) {
            echo $contratoId['id'];
            echo "<br>";
            /*
            foreach ($facturasPendientes as $factura) {
                if ($contratoId['id'] == $factura['id']) {
                    $cont++;
                    array_push($aux, $factura);
                }
            }*/
        }
        // return response()->json($aux);
        $datos2 = $datos;
        // mas de 3 facturas
        $meta = $datos2['meta'];
        $pagination = $meta['pagination'];
        $cantFacturas = $pagination['total_records'];

        if ($cantFacturas > 3) {
            $mensaje3 = Mensaje::find(3);
            $caso = 1;
            return response()->json([
                'success' => true,
                'nroCaso' => $caso,
                'cantFacturas' => $cantFacturas,
                'mensaje' => $mensaje3->mensaje,
            ], 200);
        }
        return response()->json([
            'nroCaso' => $caso,
            'success' => false,
            'cantFacturas' => $cantFacturas,
            'mensaje' => $datos2,

        ], 422);
        $soloData = $datos2['data'];

        $fechaActual = date('Y-m');
        // $fechaActual2 = '2023-06-09';





        $facturaFechaActual = '';
        $ids_facturas_pagarActual = '';
        $amountMesActual = [];
        // $nroFacturaActual = '';
        $nroFacturaActual = '';
        $estadoFacturaActual = '';
        $montoTotalActual = 0;

        $facturaFechaMesAnterior = [];
        $ids_facturas_a_pagarMes = [];
        $amountMesAnterior = [];
        $nroFacturaAnterior = [];
        $estadoFacturaAnterior = [];
        $montoTotalMesAnterior = 0;

        $auxFechaAutual = [];
        $auxFechaAnterior = [];

        foreach ($soloData as $data) {
            $fechaComoEntero = strtotime($data['issued_at']);
            $anio = date("Y-m", $fechaComoEntero);

            if ($fechaActual == $anio) {
                array_push($auxFechaAutual, $data);
                $facturaFechaActual = $data['issued_at'];
                $ids_facturas_pagarActual = $data['id'];
                $nroFacturaActual = $data['invoice_number'];
                $estadoFacturaActual = $data['state'];
                $amountMesActual[] = $data['amount'];
                $montoTotalActual = $montoTotalActual + $data['amount'];
            } else {
                array_push($auxFechaAnterior, $data);
                $facturaFechaMesAnterior[] = $data['issued_at'];
                $ids_facturas_a_pagarMes[] = $data['id'];
                $nroFacturaAnterior[] = $data['invoice_number'];
                $estadoFacturaAnterior[] = $data['state'];
                $amountMesAnterior[] = $data['amount'];
                $montoTotalMesAnterior = $montoTotalMesAnterior + $data['amount'];
            }
        }
        //para obtener el id_wispro
        $client = Client::select('id', 'id_wispro', 'name', 'email', 'custom_id')->where("custom_id", $id)->get();
        // dd(count($client));
        if (count($client) == 0) {

            $usuario = Auth::user();
            $ruta = 'clients?custom_id_eq=';
            $cliente2 = Helpers::obtenerCustomIdClientWispro($ruta, $id);
            $cli2 = $cliente2['data'];
            if (count($cli2) == 0) {
                $mensaje7 = Mensaje::find(7);
                $caso = 2;
                return response()->json([
                    'success' => true,
                    'nroCaso' => $caso,
                    'mensaje' => $mensaje7->mensaje,

                ], 200);
            }
            $cli = $cli2[0];
            $id_wispro = $cli['id'];
            $nombreCliente = $cli['name'];
            $emailCliente = $cli['email'];
            $codCliente = $cli['custom_id'];
            $idCliente = $usuario->id;
        } else {

            $id_wispro = $client[0]->id_wispro;
            $nombreCliente = $client[0]->name;
            $emailCliente = $client[0]->email;
            $codCliente = $client[0]->custom_id;
            $idCliente = $client[0]->id;
        }

        //obtenemos el contrato
        $plan_id = Helpers::obtenerPlanWispro($id_wispro);

        //obtnemos al plan registrado
        $plan2 = Helpers::obtenerPlan($plan_id);
        $plan_nombre = $plan2['name'];
        $plan_precio = $plan2['price'];
        //generar QR
        // obtener token
        $response_token = Helpers::tokenAuthBnb();
        $success = $response_token['success'];
        $fechaActual = date('d-m-Y');
        if ($success) {
            $token = $response_token['message'];
            $fech = date('m-Y');
            $gloss = 'Servicio ' . $fech . ' Cod Cli ' . $id . ' F-' . $nroFacturaActual;
            $singleUse = true;
            $expirationDate = date('Y-m-d');
            $expirationDate = date("Y-m-d", strtotime($expirationDate . "+ 1 days"));
            $hoy = date('Y-m-d H:i:s');


            $additionalData = 'Qr. generado en fecha ' . $hoy;
            $qr = Helpers::generarQrBnb($token, $gloss, $plan_precio, $singleUse, $expirationDate, $additionalData, $idCliente);

            if ($qr['success']) {

                $qr2_id = Qr::select('id')->where("id", $idCliente)->get();
                $qr_id2 = $qr2_id[0]->id;
                $qrnew = new ImagenQr();
                $qrnew->qrId = $qr['id'];
                $qrnew->imageQr = $qr['qr'];
                $qrnew->numeroFactura = $nroFacturaActual;
                $qrnew->customID = $codCliente;
                $qrnew->id_wispro = $id_wispro;
                $qrnew->state = $estadoFacturaActual;
                $qrnew->idfactura = $ids_facturas_pagarActual;
                $qrnew->qr_id = $qr_id2;

                $qrnew->save();
                // if (count($ids_facturas_pagarActual) > 0 || count($ids_facturas_a_pagarMes) > 0) {
                if ($ids_facturas_pagarActual != '' || count($ids_facturas_a_pagarMes) > 0) {
                    $mensaje8 = Mensaje::find(8);
                    $caso = 3;
                    return response()->json([
                        'nroCaso' => $caso,
                        // 'cantFacActual' => count($ids_facturas_pagarActual),
                        // 'cantFacAnterior' => count($ids_facturas_a_pagarMes),
                        // 'nroFacturaActual' => $nroFacturaActual,
                        // 'nroFacturaAnterior' => $nroFacturaAnterior,
                        // 'idsFacturaActual' => $ids_facturas_pagarActual,
                        // 'idsFacturaAnterior' => $ids_facturas_a_pagarMes,
                        // 'fechaFacturaActual' => $facturaFechaActual,
                        // 'fechaFacturaAnterior' => $facturaFechaMesAnterior,
                        // 'estadoFacturaActual' => $estadoFacturaActual,
                        // 'estadoFacturaAnterior' => $estadoFacturaAnterior,
                        // 'montoMesActual' => $amountMesActual,
                        // 'montoMesAnterior' => $amountMesAnterior,
                        // 'montoTotalMesActual' => $montoTotalActual,
                        // 'montoTotalMesAnterior' => $montoTotalMesAnterior,
                        'data' => $auxFechaAutual,
                        'nombreCliente' => $nombreCliente,
                        'emailCliente' => $emailCliente,
                        'codCliente' => $codCliente,
                        'fechaActual' => $fechaActual,
                        'plan_nombre' => $plan_nombre,
                        'plan_precio' => $plan_precio,
                        'mensaje' => $mensaje8->mensaje,
                        'qrnew' => $qrnew,
                        'qr' => $qr['qr'],
                        //'data' => $data
                    ], 200);
                } else {
                    $mensaje5 = Mensaje::find(5);
                    $caso = 4;
                    return response()->json([
                        'nroCaso' => $caso,
                        'nombreCliente' => $nombreCliente,
                        'emailCliente' => $emailCliente,
                        'codCliente' => $codCliente,
                        'fechaActual' => $fechaActual,
                        'plan_nombre' => $plan_nombre,
                        'plan_precio' => $plan_precio,
                        'mensaje' => $mensaje5->mensaje,
                        'qrnew' => $qrnew,
                        'qr' => $qr['qr'],
                    ], 200);
                }
                // if (count($ids_facturas_pagarActual) > 0 || count($ids_facturas_a_pagarMes) > 0) {
                if ($ids_facturas_pagarActual != '' || count($ids_facturas_a_pagarMes) > 0) {
                    $mensaje8 = Mensaje::find(8);
                    $caso = 3;
                    return response()->json([
                        'nroCaso' => $caso,
                        // 'cantFacActual' => count($ids_facturas_pagarActual),
                        // 'cantFacAnterior' => count($ids_facturas_a_pagarMes),
                        // 'nroFacturaActual' => $nroFacturaActual,
                        // 'nroFacturaAnterior' => $nroFacturaAnterior,
                        // 'idsFacturaActual' => $ids_facturas_pagarActual,
                        // 'idsFacturaAnterior' => $ids_facturas_a_pagarMes,
                        // 'fechaFacturaActual' => $facturaFechaActual,
                        // 'fechaFacturaAnterior' => $facturaFechaMesAnterior,
                        // 'estadoFacturaActual' => $estadoFacturaActual,
                        // 'estadoFacturaAnterior' => $estadoFacturaAnterior,
                        // 'montoMesActual' => $amountMesActual,
                        // 'montoMesAnterior' => $amountMesAnterior,
                        // 'montoTotalMesActual' => $montoTotalActual,
                        // 'montoTotalMesAnterior' => $montoTotalMesAnterior,
                        // 'data' => $aux,
                        'data' => $auxFechaAutual,
                        'nombreCliente' => $nombreCliente,
                        'emailCliente' => $emailCliente,
                        'codCliente' => $codCliente,
                        'fechaActual' => $fechaActual,
                        'plan_nombre' => $plan_nombre,
                        'plan_precio' => $plan_precio,
                        'mensaje' => $mensaje8->mensaje,

                        'qr' => $qr['qr'],
                        //'data' => $data
                    ], 200);
                } else {
                    $mensaje5 = Mensaje::find(5);
                    $caso = 4;
                    return response()->json([
                        'nroCaso' => $caso,
                        'nombreCliente' => $nombreCliente,
                        'emailCliente' => $emailCliente,
                        'codCliente' => $codCliente,
                        'fechaActual' => $fechaActual,
                        'plan_nombre' => $plan_nombre,
                        'plan_precio' => $plan_precio,
                        'mensaje' => $mensaje5->mensaje,
                        'qr' => $qr['qr'],
                    ], 200);
                }
            } else {
                return response()->json([
                    'success' => false,
                    'success' => false,
                    'message' => $qr['message'],
                ], 422);
            }
        } else {
            $mensaje6 = Mensaje::find(6);
            return response()->json([
                'nroCaso' => $caso,
                'success' => false,
                'mensaje' => $mensaje6->mensaje,

            ], 422);
        }








        //*************fin funca************* */
    }
    public function pago_facturas_adelantadas($nro_ci)
    {
        date_default_timezone_set('America/La_Paz');
        Log::channel('pagoQrBnb')->info("cont777:: " . $nro_ci);
        $caso = 0;
        //  try {
        //Nro de contratos
        // $id_client_wispro = Helpers::obtenerClienteId($id);        //
        // $contratosIdXClientes = Helpers::cantContratosClientexId($id_client_wispro[0]);
        //***$contratosIdXClientes= contrato_id,plan_id,client_id
        $contratosIdXClientes = Helpers::cantContratosClientexId($nro_ci);
        $facturasPendientes = Helpers::facturasPendientes($nro_ci);
        $facturasPendientes = $facturasPendientes['data'];



        $resumen = [];
        $precio = 0;

        // return response()->json($contratosIdXClientes); //$factura['contract_id']

        $fechaActual = date('Y-m');
        foreach ($contratosIdXClientes as $contrato) {
            $precio = Helpers::obtenerPlanXContratoId2($contrato['plan_id']);
            $cliente_titular_del_contratos = Helpers::obtenerClienteXUuid($contrato['client_id']);
            $amount = floatval($precio['precio']);
            $resumen[] = [
                'contratoId' => $contrato['contratoId'],
                'nombrePlan' => $precio['nombre'],
                'precioPlan' => $amount,
                'custom_id' => $cliente_titular_del_contratos['custom_id'],
                'name' => $cliente_titular_del_contratos['name']
            ];
            //$precio = 0;
        }

        /*         
                 
                  if (count($facturasPendientes) == 0) {
                      $mensaje4 = Mensaje::find(5);
                      $caso = 0;
                      $expirationDate = date('Y-m');
                      $expirationDate = date("Y-m", strtotime($expirationDate . "+ 1 month"));
                      return response()->json([
                          'nroCaso' => $caso,
                          //'custom_id' => $nro_ci,
                          //'id_client_wispro' => $id_client_wispro,
                          'cantFacturas' => count($facturasPendientes),
                          'fechaPago' => $expirationDate,
                          'mensaje' => $mensaje4->mensaje,
                          'resumen' => $resumen
                      ], 200);
                  }
      */
        // return response()->json($resumen);


        // return response()->json($resumen, 200);

        // return response()->json($id_client_wispro);
        // return response()->json(count($facturasPendientes));
        $aux = [];
        $auxFinal = [];
        $auxFinal2 = [];
        $idsFacturasPago = [];
        $idsFacturasPagoMesActual = [];
        $idsPago = [];
        $cont = 0;
        $fechaActual = date('d-m-Y');
        $fecha = '';
        $fechaMes = '';
        $idsFacturasPagoFechaUltimoMes = '';
        $product_code = '';
        $description_product = '';
        $amount = '';
        $numeroFactura = '';
        $cliente_uuid = '';
        // return response()->json($facturasPendientes);
        Log::channel('pagoQrBnb')->info("cantIds " . count($contratosIdXClientes));
        for ($i = 0; $i < count($contratosIdXClientes); $i++) {

            foreach ($facturasPendientes as $factura) {

                if ($contratosIdXClientes[$i]['contratoId'] == $factura['contract_id']) {
                    $cont++;
                }
                //  $facturaissued_at=$factura['issued_at'];
            }
            Log::channel('pagoQrBnb')->info("cont777:: " . $cont);
            if ($cont == 0) {

                $mensaje4 = Mensaje::find(5);
                $caso = 0;

                $expirationDate = date("d-m-Y", strtotime($fechaActual . "+ 1 month"));
                // *********************************
                $date2 = Carbon::now();
                $date = $date2->format('Y-m-d');
                $endDate = $date2->addMonth();
                $endDate = $endDate->format('Y-m-d');
                $d = new DateTime('2024-10-31');
                $d->modify('first day of +1 month');
                $dddd = $d->format('Y-m-d');
                // *********************************

                $mont = floatval($resumen[$i]['precioPlan']);


                //$mont = floatval($facturasPendientes[$i]['amount']);
                Log::channel('pagoQrBnb')->info("cantIds33333 " . $resumen[$i]['custom_id']);
                $cantIds = PagoAdelantado::select('id')
                    ->where("custom_id", $resumen[$i]['custom_id'])
                    ->where("estado", true)
                    // ->with('mespagados')
                    ->get();
                Log::channel('pagoQrBnb')->info("cantIds " . $cantIds);
                $meses_pagados = Mespagado::whereIn('pago_adelantado_id', $cantIds)
                    ->get();
                Log::channel('pagoQrBnb')->info("cantIds " . $meses_pagados);
                $auxFinal2[] = [

                    'contratoIDResumen' => $resumen[$i]['contratoId'],

                    'nroCaso' => $caso,
                    'cantFacturas' => $cont,
                    'nomPlan' => $resumen[$i]['nombrePlan'],
                    'precioPlan' => $resumen[$i]['precioPlan'],
                    'nombreCliente' => $resumen[$i]['name'],
                    'custom_id' => $resumen[$i]['custom_id'],
                    'date2' => $date,
                    'endDate' => $endDate,
                    'fechaActual' => $fechaActual,
                    'fechaPago' => $expirationDate,
                    'dddd' => $dddd,
                    'mensaje' => $mensaje4->mensaje,
                    'idsPago' => [
                        'nombreCliente' => $resumen[$i]['name'],
                        'cliente_uuid' => $contratosIdXClientes[$i]['client_id'],
                        'precioPlan' => $resumen[$i]['precioPlan'],
                        'custom_id' => $resumen[$i]['custom_id'],

                    ],
                    "meses_pagados" => $meses_pagados

                ];
            }
            $aux = [];
            $idsFacturasPago = [];
            $idsFacturasPagoMesActual = [];
            $idsPago = [];
            $idsFacturasPagoFechaUltimoMes = '';
            $cont = 0;
            $fecha = '';
            $amount = '';
            $description_product = '';
            $product_code = '';
        }

        return response()->json([
            'status' => true,
            // 'listapagos' => $empresas,
            'data' => $auxFinal2
        ], 200);
        //   } catch (\Exception $e) {
        return response()->json([
            "status" => false,
            "mensaje" => "Error al obtener pagos por adelantado.",
        ], 422);
        // }



    }
    // public function generarQrPago($cutom_id, Request $request)
    public function generarQrPagoAdelantado($id, Request $request)
    {
        date_default_timezone_set('America/La_Paz');
        //return $request->all();
        $todos_los_datos = $request->all();
        //  return $todos_los_datos;
        $request->validate([

            "cliente_uuid" => "required|exists:clients,id_wispro",
            "custom_id" => "required|exists:clients,custom_id",
            "cantMes" => "required|integer|min:1",
            "total" => "required|decimal:1|min:0",

            // "pagoTotal" => "required|decimal:2,4",
            "precioPlanBase" => "required|decimal:1|min:0|exists:planfulls,price",
            "fechaPago" => "required|string",

        ], [
            'cliente_uuid.required' => 'El id del cliente es requerido',
            'cliente_uuid.exists' => 'El id del cliente no se encuentra registrado',
            'custom_id.required' => 'El código de cliente es requerido',
            'custom_id.exists' => 'El código del cliente no se encuentra registrado',
            'cantMes.required' => 'La cantidad de meses a pagar es requerido',
            'cantMes.integer' => 'La cantidad de meses a pagar tiene que ser un entero',
            'cantMes.min' => 'La cantidad de meses tiene que ser mayor o igual a 1 mes',
            'total.required' => 'La cantidad total a pagar es requerido',
            'total.decimal' => 'La cantidad total tiene que ser decimal',
            'precioPlanBase.required' => 'El precio del plan es requerido',
            'precioPlanBase.decimal' => 'El precio del plan tiene que ser decimal',
            'precioPlanBase.exists' => 'El precio del plan no existe',
            'fechaPago.required' => 'La fecha hasta cunado se paga es requerido',
            'fechaPago.string' => 'EL campo fecha tiene formato de cadena',
        ]);
        // $time_input = strtotime("2011/05/21");
        $fechaHoy = date('d-m-Y');
        $fechaActual = strtotime($fechaHoy);
        $fecha_pago = strtotime($request->fechaPago);

        if ($fecha_pago > $fechaActual) {
            $fecha_pago = date('m-Y', $fecha_pago);
            $fechaActual = date('m-Y', $fechaActual);
            return "$fecha_pago es mayor que $fechaActual";
        } else {
            return "$fecha_pago NO es mayor que $fechaActual";
        }
        return $fechaPago;
        // validando el monto
        $cliente_uuid = $request->cliente_uuid;
        $custom_id = $request->custom_id;
        $cantMes = $request->cantMes;
        $pagoTotal = $request->total;
        $precioPlanBase = $request->precioPlanBase;
        $precioParcial = number_format($cantMes * $precioPlanBase, 1, '.', ''); //$cantMes * $precioPlanBase;
        $precioPlan = number_format($request->precioPlan, 1, '.', ''); //convertir numero a decimal de 1 decimal
        if ($pagoTotal === $precioParcial) {
        } else {
            return response()->json([
                "message" => "El total a pagar no coincide con la cantidad de meses. pagoTotal::" . $pagoTotal . " precioParcial::" . $precioParcial
            ]);
        }

        $fechaActual = date('d-m-Y');
        $mes = 1;
        $periodosPagados = [];
        for ($i = 1; $i <= $cantMes; $i++) {
            # code...

            $periodo = date("m-Y", strtotime($fechaActual . "+ " . $i . " month"));
            array_push($periodosPagados, $periodo);
        }

        /*
        $pagar = new PagoAdelantado();
        $pagar->cliente_uuid = $cliente_uuid;
        $pagar->custom_id = $custom_id;
        $pagar->nombreCliente = $request->nombreCliente;
        $pagar->cantMes = $cantMes;
        $pagar->precioPlanBase = $precioPlanBase;
        $pagar->pagoTotal = $pagoTotal;
        $pagar->fechaPago = $request->fechaPago;
        $pagar->fechaPagoDetalle = $request->fechaPagoDetalle;
        $pagar->codigo_pago = 1;
        $pagar->imagen_qr_id = 10;
        $pagar->save();
        */
        // $periodosPagados = periodos pagados del cliente
        // Grabamos en la BD

        // return $periodosPagados;

        # code...
        $fechaActual = date('d-m-Y');
        // $periodo = date("m-Y", strtotime($fechaActual . "+ 1 month"));


        $response_token = Helpers::tokenAuthBnb();
        $success = $response_token['success'];


        DB::beginTransaction();
        try {
            //generamos el token del bnb

            // return $response_token;
            if ($success) {
                $montoMes = 0;
                $montoTotalFacturas = 0;
                $ids_pagos = [];
                //111 $custom_ids = '';
                $nroFacturaActual = '';
                //111
                // foreach ($todos_los_datos as $data) {
                //     $montoMes = $montoMes + $data['precioPlan'];
                //     $custom_ids = $data['custom_id'] . ',' . $custom_ids;
                // }
                $montoMes = $precioParcial;
                $custom_ids = $custom_id;
                $token = $response_token['message'];
                $fech = date('m-Y');
                $gloss2 = $fech . ' Cod:' . $custom_ids;
                // $gloss = 'Serv.: ' . $periodo . ' Cod:' . $custom_ids;
                $gloss = 'Serv.: ' . $request->fechaPago . ' Cod:' . $custom_ids;

                $gloss2 = Str::limit($gloss, 50);
                //$gloss = strlen($gloss);
                $singleUse = true;
                $expirationDate = date('Y-m-d H:i:s');
                $expirationDate = date("Y-m-d H:i:s", strtotime($expirationDate . "+ 2 days"));
                $hoy = date('Y-m-d h:i:s');


                $additionalData = 'Qr. generado en fecha ' . $hoy;
                //HAsta aqui ya se guardo el Qr genrado en BD
                Log::channel('pagoQrBnb')->info("responseQr " .  response()->json([
                    "token" => $token,
                    "gloss2" => $gloss2,
                    "montoMes" => $montoMes,
                    "singleUse" => $singleUse,
                    "expirationDate" => $expirationDate,
                    "additionalData" => $additionalData,
                    "id" => $id,
                ]));
                $responseQr = Helpers::generarQrBnb($token, $gloss2, $montoMes, $singleUse, $expirationDate, $additionalData, $id);
                Log::channel('pagoQrBnb')->info("responseQr " .  response()->json(["mensa" => $responseQr]));

                $responseToken = $responseQr['responseToken'];


                if ($responseToken['success']) {


                    // guardamos la Imagen QR en kla BD
                    $image_qr = new ImagenQr();
                    $image_qr->custom_id = $custom_ids;
                    $image_qr->createDate = $hoy;
                    $image_qr->periodo = $request->fechaPago; //Detalle; //$periodo;
                    $image_qr->montoMes = $montoMes;
                    $image_qr->estado = 0; // 0= en proceso 1= pagado;
                    $image_qr->imageQr = $responseToken['qr'];
                    $image_qr->activo = 1;
                    $image_qr->statusId = 0;
                    $image_qr->expirationDate = $expirationDate;
                    // $image_qr->mensaje = $id_wispro;

                    $image_qr->qr_id = $responseQr['qr_id'];
                    $image_qr->client_id = $id;
                    $image_qr->save();
                    Log::info("image_qr " . $image_qr);
                    //11 foreach ($todos_los_datos as $data) {

                    $factura = new Factura();
                    // $factura->custom_id = $custom_ids;
                    //11$factura->custom_id = $data['custom_id'];
                    $factura->custom_id = $custom_id;
                    // $factura->cliente_uuid = $data['cliente_uuid'];
                    // $factura->amount = $montoMes;
                    //11$factura->amount = $data['precioPlan'];
                    $factura->amount = $precioParcial;
                    //11$factura->nombreCliente = $data['nombreCliente'];
                    $factura->nombreCliente = $request->nombreCliente;
                    // $factura->numeroFactura = $nroFacturaActual;
                    //  $factura->numeroFactura = $data['numeroFactura'];
                    $factura->periodo = $request->fechaPago; //Detalle; //$periodo;
                    $factura->estado = 0; // 0= en proceso 1= pagado
                    $factura->imprime = 0; // 0= imprime 1= No imprime
                    $factura->imagen_qr_id = $image_qr->id;
                    $factura->client_id = $id;
                    $factura->save();
                    Log::info("factura " . $factura);
                    Log::info("factura " . $factura->id);
                    // foreach ($data['idsPago'] as $data2) {
                    $pagoWispro = new PagoWispro();
                    $pagoWispro->id_invoice = '';
                    $pagoWispro->invoice_number = '';
                    //11$pagoWispro->amount = $data['precioPlan'];
                    $pagoWispro->amount = $precioParcial;
                    //11$pagoWispro->cliente_uuid = $data['cliente_uuid'];
                    $pagoWispro->cliente_uuid = $cliente_uuid;

                    $pagoWispro->factura_id = $factura->id;
                    $pagoWispro->client_id = $id;

                    $pagoWispro->save();
                    Log::info("factura " . $pagoWispro);
                    Log::info("factura " . $pagoWispro->id);
                    // }
                    $fech = date('Y-m-d H:i:s');
                    $pagar = new PagoAdelantado();
                    $pagar->cliente_uuid = $cliente_uuid;
                    $pagar->custom_id = $custom_id;
                    $pagar->nombreCliente = $request->nombreCliente;
                    $pagar->cantMes = $cantMes;
                    $pagar->precioPlanBase = $precioPlanBase;
                    $pagar->pagoTotal = $pagoTotal;
                    $pagar->fechaPago = $fech;
                    $pagar->fechaPagoDetalle = $request->fechaPago; //Detalle;
                    $pagar->codigo_pago = 1;
                    $pagar->imagen_qr_id =  $image_qr->id;
                    $pagar->descripcion =  $gloss;
                    $pagar->save();
                    Log::info("factura " . $pagar);
                    Log::info("factura " . $pagar->id);
                    //11 }
                    DB::commit();
                    return response()->json([
                        'success' => true,
                        'status' => 200,
                        'qr_image' => $responseToken['qr']
                    ], 200);
                } else {
                    return response()->json([
                        'success' => $responseQr['success'],
                        'status' => 422,
                        'responseToken' => $responseToken['success'],
                        'mensaje' => $responseQr['message']
                    ], 422);
                }
            }
        } catch (\Exception $e) {
            // Log::info("responseQr " . $responseQr);
            Log::error("error " . $e);
            DB::rollBack();

            return response()->json([
                'success' => false,
                'mensaje' => $e
            ], 422);
        }
    }
    public function generarQrPago($id, Request $request)
    {

        $todos_los_datos = $request->all();

        $response_token = Helpers::tokenAuthBnb();
        $success = $response_token['success'];

        DB::beginTransaction();
        //try {
        //generamos el token del bnb

        // return $response_token;
        if ($success) {
            $montoMes = 0;
            $montoTotalFacturas = 0;
            $ids_pagos = [];
            $custom_ids = '';
            $nroFacturaActual = '';

            foreach ($todos_los_datos as $data) {
                $montoMes = $montoMes + $data['monto'];
                $custom_ids = $data['custom_id'] . ',' . $custom_ids;
                $nroFacturaActual = $nroFacturaActual . 'F-' . $data['numeroFactura'] . ',';

                foreach ($data['idsPago'] as $data2) {

                    $montoTotalFacturas = $montoTotalFacturas + floatval($data2['amount']);
                    $ids_pagos[] = [
                        'id' => $data2['id'],
                        'invoice_number' => $data2['invoice_number'],
                        'amount' => $data2['amount'],
                        // 'client_IDD' => $custom_ids = $data['client_id'],
                    ];
                }
            }

            $token = $response_token['message'];
            $fech = date('m-Y');
            $gloss2 = $fech . ' Cod:' . $custom_ids;
            $gloss = 'Serv.: ' . $fech . ' Cod:' . $custom_ids;

            $gloss2 = Str::limit($gloss, 50);
            $gloss = strlen($gloss);
            $singleUse = true;
            $expirationDate = date('Y-m-d H:i:s');
            $expirationDate = date("Y-m-d H:i:s", strtotime($expirationDate . "+ 2 days"));
            $hoy = date('Y-m-d h:i:s');


            $additionalData = 'Qr. generado en fecha ' . $hoy;
            //HAsta aqui ya se guardo el Qr genrado en BD
            $responseQr = Helpers::generarQrBnb($token, $gloss2, $montoMes, $singleUse, $expirationDate, $additionalData, $id);
            $responseToken = $responseQr['responseToken'];


            if ($responseToken['success']) {


                // guardamos la Imagen QR en kla BD
                $image_qr = new ImagenQr();
                $image_qr->custom_id = $custom_ids;
                $image_qr->createDate = $hoy;
                $image_qr->periodo = $fech;
                $image_qr->montoMes = $montoMes;
                $image_qr->estado = 0; // 0= en proceso 1= pagado;
                $image_qr->imageQr = $responseToken['qr'];
                $image_qr->activo = 1; // 0= en proceso 1= pagado;

                $image_qr->statusId = 0;
                $image_qr->expirationDate = $expirationDate;
                // $image_qr->mensaje = $id_wispro;
                $image_qr->qr_id = $responseQr['qr_id'];
                $image_qr->client_id = $id;
                $image_qr->save();
                foreach ($todos_los_datos as $data) {


                    $factura = new Factura();
                    // $factura->custom_id = $custom_ids;
                    $factura->custom_id = $data['custom_id'];
                    // $factura->cliente_uuid = $data['cliente_uuid'];
                    // $factura->amount = $montoMes;
                    $factura->amount = $data['monto'];
                    $factura->nombreCliente = $data['nombreCliente'];
                    // $factura->numeroFactura = $nroFacturaActual;
                    $factura->numeroFactura = $data['numeroFactura'];
                    $factura->periodo = $data['fecha'];
                    $factura->estado = 0; // 0= en proceso 1= pagado
                    $factura->imprime = 0; // 0= imprime 1= No imprime
                    $factura->imagen_qr_id = $image_qr->id;
                    $factura->client_id = $id;
                    $factura->save();
                    foreach ($data['idsPago'] as $data2) {
                        $pagoWispro = new PagoWispro();
                        $pagoWispro->id_invoice = $data2['id'];
                        $pagoWispro->invoice_number = $data2['invoice_number'];
                        $pagoWispro->amount = $data2['amount'];
                        $pagoWispro->cliente_uuid = $data['cliente_uuid'];;
                        $pagoWispro->factura_id = $factura->id;
                        $pagoWispro->client_id = $id;

                        $pagoWispro->save();
                    }
                }
                DB::commit();
                return response()->json([
                    'success' => true,
                    'qr_image' => $responseToken['qr']
                ]);
            } else {
                return response()->json([
                    'success' => $responseQr['success'],
                    'mensaje' => $responseQr['message']
                ]);
            }
        }
        /*
          } catch (\Exception $e) {
              DB::rollBack();

              return response()->json([
                  'success' => $success,
                  'mensaje' => $response_token['message']
              ], 422);
          }
  */

        /*
                if ($success) {
                    $token = $response_token['message'];
                    $fech = date('m-Y');
                    $gloss2 = $fech . ' Cod:' . $custom_ids;
                    $gloss = 'Serv.: ' . $fech . ' Cod:' . $custom_ids;

                    $gloss2 = Str::limit($gloss, 50);
                    $gloss = strlen($gloss);
                    $singleUse = true;
                    $expirationDate = date('Y-m-d H:i:s');
                    $expirationDate = date("Y-m-d H:i:s", strtotime($expirationDate . "+ 2 days"));
                    $hoy = date('Y-m-d h:i:s');


                    $additionalData = 'Qr. generado en fecha ' . $hoy;
                    $qr = Helpers::generarQrBnb($token, $gloss2, $montoMes, $singleUse, $expirationDate, $additionalData);

                    $qr_idnew = $qr['id'];
                    $success = $qr['success'];

                    // return response()->json([
                    //     'cant_Facturas' => count($todos_los_datos),
                    //     //'nombreCliente' => $request->nombreCliente,
                    //     'montoMes' => $montoMes,
                    //     'data' => $todos_los_datos,
                    //     'ids_pagos' => $ids_pagos,
                    //     'montoTotalFacturas' => $montoTotalFacturas,
                    //     'response_token' => $response_token,
                    //     'nroFacturaActual' => $nroFacturaActual,
                    //     'custom_ids' => $custom_ids,
                    //     'gloss' => $gloss2,
                    //     'qrResult' => $qr,

                    //     'success' => $success,
                    //     'qr_id' => $qr_id,
                    // ], 200);

                    if ($success) {



                        $factura = new Factura();
                        $factura->qrId = $qr['id'];
                        $factura->imageQr = $qr['qr'];
                        $factura->numeroFactura = $nroFacturaActual;
                        $factura->customID = $codCliente;
                        $factura->id_wispro = $id_wispro;
                        $factura->state = $estadoFacturaActual;
                        $factura->idfactura = $ids_facturas_pagarActual;
                        $factura->qr_id = $qr_id2;

                        $factura->save();
                        // if (count($ids_facturas_pagarActual) > 0 || count($ids_facturas_a_pagarMes) > 0) {
                        if ($ids_facturas_pagarActual != '' || count($ids_facturas_a_pagarMes) > 0) {
                            $mensaje8 = Mensaje::find(8);
                            $caso = 3;
                            return response()->json([
                                'nroCaso' => $caso,
                                // 'cantFacActual' => count($ids_facturas_pagarActual),
                                // 'cantFacAnterior' => count($ids_facturas_a_pagarMes),
                                // 'nroFacturaActual' => $nroFacturaActual,
                                // 'nroFacturaAnterior' => $nroFacturaAnterior,
                                // 'idsFacturaActual' => $ids_facturas_pagarActual,
                                // 'idsFacturaAnterior' => $ids_facturas_a_pagarMes,
                                // 'fechaFacturaActual' => $facturaFechaActual,
                                // 'fechaFacturaAnterior' => $facturaFechaMesAnterior,
                                // 'estadoFacturaActual' => $estadoFacturaActual,
                                // 'estadoFacturaAnterior' => $estadoFacturaAnterior,
                                // 'montoMesActual' => $amountMesActual,
                                // 'montoMesAnterior' => $amountMesAnterior,
                                // 'montoTotalMesActual' => $montoTotalActual,
                                // 'montoTotalMesAnterior' => $montoTotalMesAnterior,
                                'data' => $auxFechaAutual,
                                'nombreCliente' => $nombreCliente,
                                'emailCliente' => $emailCliente,
                                'codCliente' => $codCliente,
                                'fechaActual' => $fechaActual,
                                'plan_nombre' => $plan_nombre,
                                'plan_precio' => $plan_precio,
                                'mensaje' => $mensaje8->mensaje,
                                'qrnew' => $qrnew,
                                'qr' => $qr['qr'],
                                //'data' => $data
                            ], 200);
                        } else {
                            $mensaje5 = Mensaje::find(5);
                            $caso = 4;
                            return response()->json([
                                'nroCaso' => $caso,
                                'nombreCliente' => $nombreCliente,
                                'emailCliente' => $emailCliente,
                                'codCliente' => $codCliente,
                                'fechaActual' => $fechaActual,
                                'plan_nombre' => $plan_nombre,
                                'plan_precio' => $plan_precio,
                                'mensaje' => $mensaje5->mensaje,
                                'qrnew' => $qrnew,
                                'qr' => $qr['qr'],
                            ], 200);
                        }
                        // if (count($ids_facturas_pagarActual) > 0 || count($ids_facturas_a_pagarMes) > 0) {
                        if ($ids_facturas_pagarActual != '' || count($ids_facturas_a_pagarMes) > 0) {
                            $mensaje8 = Mensaje::find(8);
                            $caso = 3;
                            return response()->json([
                                'nroCaso' => $caso,
                                // 'cantFacActual' => count($ids_facturas_pagarActual),
                                // 'cantFacAnterior' => count($ids_facturas_a_pagarMes),
                                // 'nroFacturaActual' => $nroFacturaActual,
                                // 'nroFacturaAnterior' => $nroFacturaAnterior,
                                // 'idsFacturaActual' => $ids_facturas_pagarActual,
                                // 'idsFacturaAnterior' => $ids_facturas_a_pagarMes,
                                // 'fechaFacturaActual' => $facturaFechaActual,
                                // 'fechaFacturaAnterior' => $facturaFechaMesAnterior,
                                // 'estadoFacturaActual' => $estadoFacturaActual,
                                // 'estadoFacturaAnterior' => $estadoFacturaAnterior,
                                // 'montoMesActual' => $amountMesActual,
                                // 'montoMesAnterior' => $amountMesAnterior,
                                // 'montoTotalMesActual' => $montoTotalActual,
                                // 'montoTotalMesAnterior' => $montoTotalMesAnterior,
                                // 'data' => $aux,
                                'data' => $auxFechaAutual,
                                'nombreCliente' => $nombreCliente,
                                'emailCliente' => $emailCliente,
                                'codCliente' => $codCliente,
                                'fechaActual' => $fechaActual,
                                'plan_nombre' => $plan_nombre,
                                'plan_precio' => $plan_precio,
                                'mensaje' => $mensaje8->mensaje,

                                'qr' => $qr['qr'],
                                //'data' => $data
                            ], 200);
                        } else {
                            $mensaje5 = Mensaje::find(5);
                            $caso = 4;
                            return response()->json([
                                'nroCaso' => $caso,
                                'nombreCliente' => $nombreCliente,
                                'emailCliente' => $emailCliente,
                                'codCliente' => $codCliente,
                                'fechaActual' => $fechaActual,
                                'plan_nombre' => $plan_nombre,
                                'plan_precio' => $plan_precio,
                                'mensaje' => $mensaje5->mensaje,
                                'qr' => $qr['qr'],
                            ], 200);
                        }
                    } else {
                        return response()->json([
                            'success' => false,
                            'success' => false,
                            'message' => $qr['message'],
                        ], 422);
                    }

                } else {
                    $mensaje6 = Mensaje::find(6);
                    return response()->json([
                        // 'nroCaso' => $caso,
                        'success' => false,
                        'mensaje' => $mensaje6->mensaje,

                    ], 422);
                }
        */
        /*
         return response()->json([
                    'cant_Facturas' => count($todos_los_datos),
                    //'nombreCliente' => $request->nombreCliente,
                    'montoMes' => $montoMes,
                    'data' => $todos_los_datos,
                    'ids_pagos' => $ids_pagos,
                    'montoTotalFacturas' => $montoTotalFacturas,
                    'response_token' => $response_token,
                ], 200);
         */
        /*
                $fechaActual = date('d-m-Y');
                if ($success) {
                    $token = $response_token['message'];
                    $fech = date('m-Y');
                    $gloss = 'Servicio ' . $fech . ' Cod Cli ' . $id . ' F-' . $nroFacturaActual;
                    $singleUse = true;
                    $expirationDate = date('Y-m-d');
                    $expirationDate = date("Y-m-d", strtotime($expirationDate . "+ 1 days"));
                    $hoy = date('Y-m-d H:i:s');


                    $additionalData = 'Qr. generado en fecha ' . $hoy;
                    $qr = Helpers::generarQrBnb($token, $gloss, $plan_precio, $singleUse, $expirationDate, $additionalData, $idCliente);

                    if ($qr['success']) {

                        $qr2_id = Qr::select('id')->where("id", $idCliente)->get();
                        $qr_id2 = $qr2_id[0]->id;
                        $qrnew = new ImagenQr();
                        $qrnew->qrId = $qr['id'];
                        $qrnew->imageQr = $qr['qr'];
                        $qrnew->numeroFactura = $nroFacturaActual;
                        $qrnew->customID = $codCliente;
                        $qrnew->id_wispro = $id_wispro;
                        $qrnew->state = $estadoFacturaActual;
                        $qrnew->idfactura = $ids_facturas_pagarActual;
                        $qrnew->qr_id = $qr_id2;

                        $qrnew->save();
                        // if (count($ids_facturas_pagarActual) > 0 || count($ids_facturas_a_pagarMes) > 0) {
                        if ($ids_facturas_pagarActual != '' || count($ids_facturas_a_pagarMes) > 0) {
                            $mensaje8 = Mensaje::find(8);
                            $caso = 3;
                            return response()->json([
                                'nroCaso' => $caso,
                                // 'cantFacActual' => count($ids_facturas_pagarActual),
                                // 'cantFacAnterior' => count($ids_facturas_a_pagarMes),
                                // 'nroFacturaActual' => $nroFacturaActual,
                                // 'nroFacturaAnterior' => $nroFacturaAnterior,
                                // 'idsFacturaActual' => $ids_facturas_pagarActual,
                                // 'idsFacturaAnterior' => $ids_facturas_a_pagarMes,
                                // 'fechaFacturaActual' => $facturaFechaActual,
                                // 'fechaFacturaAnterior' => $facturaFechaMesAnterior,
                                // 'estadoFacturaActual' => $estadoFacturaActual,
                                // 'estadoFacturaAnterior' => $estadoFacturaAnterior,
                                // 'montoMesActual' => $amountMesActual,
                                // 'montoMesAnterior' => $amountMesAnterior,
                                // 'montoTotalMesActual' => $montoTotalActual,
                                // 'montoTotalMesAnterior' => $montoTotalMesAnterior,
                                'data' => $auxFechaAutual,
                                'nombreCliente' => $nombreCliente,
                                'emailCliente' => $emailCliente,
                                'codCliente' => $codCliente,
                                'fechaActual' => $fechaActual,
                                'plan_nombre' => $plan_nombre,
                                'plan_precio' => $plan_precio,
                                'mensaje' => $mensaje8->mensaje,
                                'qrnew' => $qrnew,
                                'qr' => $qr['qr'],
                                //'data' => $data
                            ], 200);
                        } else {
                            $mensaje5 = Mensaje::find(5);
                            $caso = 4;
                            return response()->json([
                                'nroCaso' => $caso,
                                'nombreCliente' => $nombreCliente,
                                'emailCliente' => $emailCliente,
                                'codCliente' => $codCliente,
                                'fechaActual' => $fechaActual,
                                'plan_nombre' => $plan_nombre,
                                'plan_precio' => $plan_precio,
                                'mensaje' => $mensaje5->mensaje,
                                'qrnew' => $qrnew,
                                'qr' => $qr['qr'],
                            ], 200);
                        }
                        // if (count($ids_facturas_pagarActual) > 0 || count($ids_facturas_a_pagarMes) > 0) {
                        if ($ids_facturas_pagarActual != '' || count($ids_facturas_a_pagarMes) > 0) {
                            $mensaje8 = Mensaje::find(8);
                            $caso = 3;
                            return response()->json([
                                'nroCaso' => $caso,
                                // 'cantFacActual' => count($ids_facturas_pagarActual),
                                // 'cantFacAnterior' => count($ids_facturas_a_pagarMes),
                                // 'nroFacturaActual' => $nroFacturaActual,
                                // 'nroFacturaAnterior' => $nroFacturaAnterior,
                                // 'idsFacturaActual' => $ids_facturas_pagarActual,
                                // 'idsFacturaAnterior' => $ids_facturas_a_pagarMes,
                                // 'fechaFacturaActual' => $facturaFechaActual,
                                // 'fechaFacturaAnterior' => $facturaFechaMesAnterior,
                                // 'estadoFacturaActual' => $estadoFacturaActual,
                                // 'estadoFacturaAnterior' => $estadoFacturaAnterior,
                                // 'montoMesActual' => $amountMesActual,
                                // 'montoMesAnterior' => $amountMesAnterior,
                                // 'montoTotalMesActual' => $montoTotalActual,
                                // 'montoTotalMesAnterior' => $montoTotalMesAnterior,
                                // 'data' => $aux,
                                'data' => $auxFechaAutual,
                                'nombreCliente' => $nombreCliente,
                                'emailCliente' => $emailCliente,
                                'codCliente' => $codCliente,
                                'fechaActual' => $fechaActual,
                                'plan_nombre' => $plan_nombre,
                                'plan_precio' => $plan_precio,
                                'mensaje' => $mensaje8->mensaje,

                                'qr' => $qr['qr'],
                                //'data' => $data
                            ], 200);
                        } else {
                            $mensaje5 = Mensaje::find(5);
                            $caso = 4;
                            return response()->json([
                                'nroCaso' => $caso,
                                'nombreCliente' => $nombreCliente,
                                'emailCliente' => $emailCliente,
                                'codCliente' => $codCliente,
                                'fechaActual' => $fechaActual,
                                'plan_nombre' => $plan_nombre,
                                'plan_precio' => $plan_precio,
                                'mensaje' => $mensaje5->mensaje,
                                'qr' => $qr['qr'],
                            ], 200);
                        }
                    } else {
                        return response()->json([
                            'success' => false,
                            'success' => false,
                            'message' => $qr['message'],
                        ], 422);
                    }
                } else {
                    $mensaje6 = Mensaje::find(6);
                    return response()->json([
                        'nroCaso' => $caso,
                        'success' => false,
                        'mensaje' => $mensaje6->mensaje,

                    ], 422);
                }
                */
    }
    public function generarQrPagoPorCustomID($id, Request $request)
    {

        $todos_los_datos = $request->all();

        //$paraPagar = $todos_los_datos[0];
        // $paraPagar = $todos_los_datos[0];
        // $paraPagar = $paraPagar['paraPagar'];
        // return $paraPagar['idsPago'];
        $response_token = Helpers::tokenAuthBnb();
        $success = $response_token['success'];

        DB::beginTransaction();
        //try {
        //generamos el token del bnb

        // return $response_token;
        if ($success) {
            $montoMes = 0;
            $montoTotalFacturas = 0;
            $ids_pagos = [];
            $custom_ids = '';
            $nroFacturaActual = '';

            foreach ($todos_los_datos as $data) {
                $montoMes = $montoMes + $data['monto'];
                $custom_ids = $data['custom_id'] . ',' . $custom_ids;
                $nroFacturaActual = $nroFacturaActual . 'F-' . $data['numeroFactura'] . ',';
                $paraPagar = $todos_los_datos[0];
                $paraPagar = $paraPagar['paraPagar'];
                foreach ($paraPagar['idsPago'] as $data2) {


                    $montoTotalFacturas = $montoTotalFacturas + floatval($data2['amount']);
                    $ids_pagos[] = [
                        'id' => $data2['id'],
                        'invoice_number' => $data2['invoice_number'],
                        'amount' => $data2['amount'],
                        // 'client_IDD' => $custom_ids = $data['client_id'],
                    ];
                }
            }

            $token = $response_token['message'];
            $fech = date('m-Y');
            $gloss2 = $fech . ' Cod:' . $custom_ids;
            $gloss = 'Serv.: ' . $fech . ' Cod:' . $custom_ids;

            $gloss2 = Str::limit($gloss, 50);
            $gloss = strlen($gloss);
            $singleUse = true;
            $expirationDate = date('Y-m-d H:i:s');
            $expirationDate = date("Y-m-d H:i:s", strtotime($expirationDate . "+ 2 days"));
            $hoy = date('Y-m-d h:i:s');


            $additionalData = 'Qr. generado en fecha ' . $hoy;
            //HAsta aqui ya se guardo el Qr genrado en BD
            $responseQr = Helpers::generarQrBnb($token, $gloss2, $montoMes, $singleUse, $expirationDate, $additionalData, $id);
            // return $responseQr;
            $responseToken = $responseQr['responseToken'];


            if ($responseToken['success']) {


                // guardamos la Imagen QR en kla BD
                $image_qr = new ImagenQr();
                $image_qr->custom_id = $custom_ids;
                $image_qr->createDate = $hoy;
                $image_qr->periodo = $fech;
                $image_qr->montoMes = $montoMes;
                $image_qr->estado = 0; // 0= en proceso 1= pagado;
                $image_qr->imageQr = $responseToken['qr'];
                $image_qr->activo = 1;
                $image_qr->statusId = 0;
                //$image_qr->statusId = $nroFacturaActual;
                $image_qr->expirationDate = $expirationDate;
                // $image_qr->mensaje = $id_wispro;
                $image_qr->qr_id = $responseQr['qr_id'];
                $image_qr->client_id = $id;
                $image_qr->save();
                foreach ($todos_los_datos as $data) {


                    $factura = new Factura();
                    // $factura->custom_id = $custom_ids;
                    $factura->custom_id = $data['custom_id'];
                    // $factura->cliente_uuid = $data['cliente_uuid'];
                    // $factura->amount = $montoMes;
                    $factura->amount = $data['monto'];
                    $factura->nombreCliente = $data['nombreCliente'];
                    // $factura->numeroFactura = $nroFacturaActual;
                    $factura->numeroFactura = $data['numeroFactura'];
                    $factura->periodo = $data['fecha'];
                    $factura->estado = 0; // 0= en proceso 1= pagado
                    $factura->imprime = 0; // 0= imprime 1= No imprime
                    $factura->imagen_qr_id = $image_qr->id;
                    $factura->client_id = $id;
                    $factura->save();
                    $paraPagar = $todos_los_datos[0];
                    $paraPagar = $paraPagar['paraPagar'];
                    foreach ($paraPagar['idsPago'] as $data2) {
                        $pagoWispro = new PagoWispro();
                        $pagoWispro->id_invoice = $data2['id'];
                        $pagoWispro->invoice_number = $data2['invoice_number'];
                        $pagoWispro->amount = $data2['amount'];
                        $pagoWispro->cliente_uuid = $data['cliente_uuid'];;
                        $pagoWispro->factura_id = $factura->id;
                        $pagoWispro->client_id = $id;

                        $pagoWispro->save();
                    }
                }
                DB::commit();
                return response()->json([
                    'success' => true,
                    'qr_image' => $responseToken['qr']
                ]);
            } else {
                return response()->json([
                    'success' => $responseToken['success'],
                    'mensaje' => $responseToken['message']
                ]);
            }
        }
        /*
          } catch (\Exception $e) {
              DB::rollBack();

              return response()->json([
                  'success' => $success,
                  'mensaje' => $response_token['message']
              ], 422);
          }
  */

        /*
                if ($success) {
                    $token = $response_token['message'];
                    $fech = date('m-Y');
                    $gloss2 = $fech . ' Cod:' . $custom_ids;
                    $gloss = 'Serv.: ' . $fech . ' Cod:' . $custom_ids;

                    $gloss2 = Str::limit($gloss, 50);
                    $gloss = strlen($gloss);
                    $singleUse = true;
                    $expirationDate = date('Y-m-d H:i:s');
                    $expirationDate = date("Y-m-d H:i:s", strtotime($expirationDate . "+ 2 days"));
                    $hoy = date('Y-m-d h:i:s');


                    $additionalData = 'Qr. generado en fecha ' . $hoy;
                    $qr = Helpers::generarQrBnb($token, $gloss2, $montoMes, $singleUse, $expirationDate, $additionalData);

                    $qr_idnew = $qr['id'];
                    $success = $qr['success'];

                    // return response()->json([
                    //     'cant_Facturas' => count($todos_los_datos),
                    //     //'nombreCliente' => $request->nombreCliente,
                    //     'montoMes' => $montoMes,
                    //     'data' => $todos_los_datos,
                    //     'ids_pagos' => $ids_pagos,
                    //     'montoTotalFacturas' => $montoTotalFacturas,
                    //     'response_token' => $response_token,
                    //     'nroFacturaActual' => $nroFacturaActual,
                    //     'custom_ids' => $custom_ids,
                    //     'gloss' => $gloss2,
                    //     'qrResult' => $qr,

                    //     'success' => $success,
                    //     'qr_id' => $qr_id,
                    // ], 200);

                    if ($success) {



                        $factura = new Factura();
                        $factura->qrId = $qr['id'];
                        $factura->imageQr = $qr['qr'];
                        $factura->numeroFactura = $nroFacturaActual;
                        $factura->customID = $codCliente;
                        $factura->id_wispro = $id_wispro;
                        $factura->state = $estadoFacturaActual;
                        $factura->idfactura = $ids_facturas_pagarActual;
                        $factura->qr_id = $qr_id2;

                        $factura->save();
                        // if (count($ids_facturas_pagarActual) > 0 || count($ids_facturas_a_pagarMes) > 0) {
                        if ($ids_facturas_pagarActual != '' || count($ids_facturas_a_pagarMes) > 0) {
                            $mensaje8 = Mensaje::find(8);
                            $caso = 3;
                            return response()->json([
                                'nroCaso' => $caso,
                                // 'cantFacActual' => count($ids_facturas_pagarActual),
                                // 'cantFacAnterior' => count($ids_facturas_a_pagarMes),
                                // 'nroFacturaActual' => $nroFacturaActual,
                                // 'nroFacturaAnterior' => $nroFacturaAnterior,
                                // 'idsFacturaActual' => $ids_facturas_pagarActual,
                                // 'idsFacturaAnterior' => $ids_facturas_a_pagarMes,
                                // 'fechaFacturaActual' => $facturaFechaActual,
                                // 'fechaFacturaAnterior' => $facturaFechaMesAnterior,
                                // 'estadoFacturaActual' => $estadoFacturaActual,
                                // 'estadoFacturaAnterior' => $estadoFacturaAnterior,
                                // 'montoMesActual' => $amountMesActual,
                                // 'montoMesAnterior' => $amountMesAnterior,
                                // 'montoTotalMesActual' => $montoTotalActual,
                                // 'montoTotalMesAnterior' => $montoTotalMesAnterior,
                                'data' => $auxFechaAutual,
                                'nombreCliente' => $nombreCliente,
                                'emailCliente' => $emailCliente,
                                'codCliente' => $codCliente,
                                'fechaActual' => $fechaActual,
                                'plan_nombre' => $plan_nombre,
                                'plan_precio' => $plan_precio,
                                'mensaje' => $mensaje8->mensaje,
                                'qrnew' => $qrnew,
                                'qr' => $qr['qr'],
                                //'data' => $data
                            ], 200);
                        } else {
                            $mensaje5 = Mensaje::find(5);
                            $caso = 4;
                            return response()->json([
                                'nroCaso' => $caso,
                                'nombreCliente' => $nombreCliente,
                                'emailCliente' => $emailCliente,
                                'codCliente' => $codCliente,
                                'fechaActual' => $fechaActual,
                                'plan_nombre' => $plan_nombre,
                                'plan_precio' => $plan_precio,
                                'mensaje' => $mensaje5->mensaje,
                                'qrnew' => $qrnew,
                                'qr' => $qr['qr'],
                            ], 200);
                        }
                        // if (count($ids_facturas_pagarActual) > 0 || count($ids_facturas_a_pagarMes) > 0) {
                        if ($ids_facturas_pagarActual != '' || count($ids_facturas_a_pagarMes) > 0) {
                            $mensaje8 = Mensaje::find(8);
                            $caso = 3;
                            return response()->json([
                                'nroCaso' => $caso,
                                // 'cantFacActual' => count($ids_facturas_pagarActual),
                                // 'cantFacAnterior' => count($ids_facturas_a_pagarMes),
                                // 'nroFacturaActual' => $nroFacturaActual,
                                // 'nroFacturaAnterior' => $nroFacturaAnterior,
                                // 'idsFacturaActual' => $ids_facturas_pagarActual,
                                // 'idsFacturaAnterior' => $ids_facturas_a_pagarMes,
                                // 'fechaFacturaActual' => $facturaFechaActual,
                                // 'fechaFacturaAnterior' => $facturaFechaMesAnterior,
                                // 'estadoFacturaActual' => $estadoFacturaActual,
                                // 'estadoFacturaAnterior' => $estadoFacturaAnterior,
                                // 'montoMesActual' => $amountMesActual,
                                // 'montoMesAnterior' => $amountMesAnterior,
                                // 'montoTotalMesActual' => $montoTotalActual,
                                // 'montoTotalMesAnterior' => $montoTotalMesAnterior,
                                // 'data' => $aux,
                                'data' => $auxFechaAutual,
                                'nombreCliente' => $nombreCliente,
                                'emailCliente' => $emailCliente,
                                'codCliente' => $codCliente,
                                'fechaActual' => $fechaActual,
                                'plan_nombre' => $plan_nombre,
                                'plan_precio' => $plan_precio,
                                'mensaje' => $mensaje8->mensaje,

                                'qr' => $qr['qr'],
                                //'data' => $data
                            ], 200);
                        } else {
                            $mensaje5 = Mensaje::find(5);
                            $caso = 4;
                            return response()->json([
                                'nroCaso' => $caso,
                                'nombreCliente' => $nombreCliente,
                                'emailCliente' => $emailCliente,
                                'codCliente' => $codCliente,
                                'fechaActual' => $fechaActual,
                                'plan_nombre' => $plan_nombre,
                                'plan_precio' => $plan_precio,
                                'mensaje' => $mensaje5->mensaje,
                                'qr' => $qr['qr'],
                            ], 200);
                        }
                    } else {
                        return response()->json([
                            'success' => false,
                            'success' => false,
                            'message' => $qr['message'],
                        ], 422);
                    }

                } else {
                    $mensaje6 = Mensaje::find(6);
                    return response()->json([
                        // 'nroCaso' => $caso,
                        'success' => false,
                        'mensaje' => $mensaje6->mensaje,

                    ], 422);
                }
        */
        /*
         return response()->json([
                    'cant_Facturas' => count($todos_los_datos),
                    //'nombreCliente' => $request->nombreCliente,
                    'montoMes' => $montoMes,
                    'data' => $todos_los_datos,
                    'ids_pagos' => $ids_pagos,
                    'montoTotalFacturas' => $montoTotalFacturas,
                    'response_token' => $response_token,
                ], 200);
         */
        /*
                $fechaActual = date('d-m-Y');
                if ($success) {
                    $token = $response_token['message'];
                    $fech = date('m-Y');
                    $gloss = 'Servicio ' . $fech . ' Cod Cli ' . $id . ' F-' . $nroFacturaActual;
                    $singleUse = true;
                    $expirationDate = date('Y-m-d');
                    $expirationDate = date("Y-m-d", strtotime($expirationDate . "+ 1 days"));
                    $hoy = date('Y-m-d H:i:s');


                    $additionalData = 'Qr. generado en fecha ' . $hoy;
                    $qr = Helpers::generarQrBnb($token, $gloss, $plan_precio, $singleUse, $expirationDate, $additionalData, $idCliente);

                    if ($qr['success']) {

                        $qr2_id = Qr::select('id')->where("id", $idCliente)->get();
                        $qr_id2 = $qr2_id[0]->id;
                        $qrnew = new ImagenQr();
                        $qrnew->qrId = $qr['id'];
                        $qrnew->imageQr = $qr['qr'];
                        $qrnew->numeroFactura = $nroFacturaActual;
                        $qrnew->customID = $codCliente;
                        $qrnew->id_wispro = $id_wispro;
                        $qrnew->state = $estadoFacturaActual;
                        $qrnew->idfactura = $ids_facturas_pagarActual;
                        $qrnew->qr_id = $qr_id2;

                        $qrnew->save();
                        // if (count($ids_facturas_pagarActual) > 0 || count($ids_facturas_a_pagarMes) > 0) {
                        if ($ids_facturas_pagarActual != '' || count($ids_facturas_a_pagarMes) > 0) {
                            $mensaje8 = Mensaje::find(8);
                            $caso = 3;
                            return response()->json([
                                'nroCaso' => $caso,
                                // 'cantFacActual' => count($ids_facturas_pagarActual),
                                // 'cantFacAnterior' => count($ids_facturas_a_pagarMes),
                                // 'nroFacturaActual' => $nroFacturaActual,
                                // 'nroFacturaAnterior' => $nroFacturaAnterior,
                                // 'idsFacturaActual' => $ids_facturas_pagarActual,
                                // 'idsFacturaAnterior' => $ids_facturas_a_pagarMes,
                                // 'fechaFacturaActual' => $facturaFechaActual,
                                // 'fechaFacturaAnterior' => $facturaFechaMesAnterior,
                                // 'estadoFacturaActual' => $estadoFacturaActual,
                                // 'estadoFacturaAnterior' => $estadoFacturaAnterior,
                                // 'montoMesActual' => $amountMesActual,
                                // 'montoMesAnterior' => $amountMesAnterior,
                                // 'montoTotalMesActual' => $montoTotalActual,
                                // 'montoTotalMesAnterior' => $montoTotalMesAnterior,
                                'data' => $auxFechaAutual,
                                'nombreCliente' => $nombreCliente,
                                'emailCliente' => $emailCliente,
                                'codCliente' => $codCliente,
                                'fechaActual' => $fechaActual,
                                'plan_nombre' => $plan_nombre,
                                'plan_precio' => $plan_precio,
                                'mensaje' => $mensaje8->mensaje,
                                'qrnew' => $qrnew,
                                'qr' => $qr['qr'],
                                //'data' => $data
                            ], 200);
                        } else {
                            $mensaje5 = Mensaje::find(5);
                            $caso = 4;
                            return response()->json([
                                'nroCaso' => $caso,
                                'nombreCliente' => $nombreCliente,
                                'emailCliente' => $emailCliente,
                                'codCliente' => $codCliente,
                                'fechaActual' => $fechaActual,
                                'plan_nombre' => $plan_nombre,
                                'plan_precio' => $plan_precio,
                                'mensaje' => $mensaje5->mensaje,
                                'qrnew' => $qrnew,
                                'qr' => $qr['qr'],
                            ], 200);
                        }
                        // if (count($ids_facturas_pagarActual) > 0 || count($ids_facturas_a_pagarMes) > 0) {
                        if ($ids_facturas_pagarActual != '' || count($ids_facturas_a_pagarMes) > 0) {
                            $mensaje8 = Mensaje::find(8);
                            $caso = 3;
                            return response()->json([
                                'nroCaso' => $caso,
                                // 'cantFacActual' => count($ids_facturas_pagarActual),
                                // 'cantFacAnterior' => count($ids_facturas_a_pagarMes),
                                // 'nroFacturaActual' => $nroFacturaActual,
                                // 'nroFacturaAnterior' => $nroFacturaAnterior,
                                // 'idsFacturaActual' => $ids_facturas_pagarActual,
                                // 'idsFacturaAnterior' => $ids_facturas_a_pagarMes,
                                // 'fechaFacturaActual' => $facturaFechaActual,
                                // 'fechaFacturaAnterior' => $facturaFechaMesAnterior,
                                // 'estadoFacturaActual' => $estadoFacturaActual,
                                // 'estadoFacturaAnterior' => $estadoFacturaAnterior,
                                // 'montoMesActual' => $amountMesActual,
                                // 'montoMesAnterior' => $amountMesAnterior,
                                // 'montoTotalMesActual' => $montoTotalActual,
                                // 'montoTotalMesAnterior' => $montoTotalMesAnterior,
                                // 'data' => $aux,
                                'data' => $auxFechaAutual,
                                'nombreCliente' => $nombreCliente,
                                'emailCliente' => $emailCliente,
                                'codCliente' => $codCliente,
                                'fechaActual' => $fechaActual,
                                'plan_nombre' => $plan_nombre,
                                'plan_precio' => $plan_precio,
                                'mensaje' => $mensaje8->mensaje,

                                'qr' => $qr['qr'],
                                //'data' => $data
                            ], 200);
                        } else {
                            $mensaje5 = Mensaje::find(5);
                            $caso = 4;
                            return response()->json([
                                'nroCaso' => $caso,
                                'nombreCliente' => $nombreCliente,
                                'emailCliente' => $emailCliente,
                                'codCliente' => $codCliente,
                                'fechaActual' => $fechaActual,
                                'plan_nombre' => $plan_nombre,
                                'plan_precio' => $plan_precio,
                                'mensaje' => $mensaje5->mensaje,
                                'qr' => $qr['qr'],
                            ], 200);
                        }
                    } else {
                        return response()->json([
                            'success' => false,
                            'success' => false,
                            'message' => $qr['message'],
                        ], 422);
                    }
                } else {
                    $mensaje6 = Mensaje::find(6);
                    return response()->json([
                        'nroCaso' => $caso,
                        'success' => false,
                        'mensaje' => $mensaje6->mensaje,

                    ], 422);
                }
                */
    }
    public function promesasPago($uuidContrato)
    {
        //return true 1 false 0
        $response_token = Helpers::crearPromesasPago($uuidContrato);

        return $response_token;
    }
    public function pagar_facturas($cutom_id, Request $request)
    {
        date_default_timezone_set('America/La_Paz');
        //Obtener Facturas pendientes
        $token4 = 'https://www.cloud.wispro.co/api/v1/invoicing/invoices?state_eq=pending&client_custom_id_eq=' . $cutom_id;
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($token4);

        //$datos = json_decode($response, false);
        // echo $datos->status;

        $datos = json_decode($response, true);
        $ids_facturas_a_pagar = [];
        $name = $datos['status'];
        $countries = $datos['data'];
        $montoTotal = 0;
        foreach ($countries as $country) {
            //  echo ' visited ' . $country['id'] . ' in ' . $country['invoice_number'] . 'P.\n';
            $ids_facturas_a_pagar[] = $country['id'];
            $montoTotal = $montoTotal + $country['amount'];
        }
        //echo date(DATE_ATOM, mktime(0, 0, 0, 7, 1, 2000));
        //var_dump($ids_facturas_a_pagar);
        //echo "Monto toal=" . $montoTotal;
        //exit;

        // $fecha_actual = date("Y-m-d h:i:s");
        //echo $fecha_actual;

        // date_format(date_timestamp_set(new DateTime(), 1326883500), 'c');
        //  echo date_format(date_create('@' . 1326883500), 'c') . "<br>";
        //echo date("l jS \of F Y h:i:s A") . "<br>";
        $funca = date('Y-m-d h:i:s');
        //    echo $funca . "<br>";
        //  echo date(DATE_ATOM, mktime(0, 0, 0, 10, 3, 1975));
        // echo "************************************<br>";
        // echo date(DATE_ATOM, mktime(0, 0, 0, 10, 3, 1975));
        // echo "************************************<br>";
        // $datetime = new DateTime('2021-01-03 02:30:00', new DateTimeZone('Europe/Berlin'));
        $datetime = new DateTime($funca, new DateTimeZone('America/La_Paz'));
        //echo "************************************<br>";
        $tiempo = $datetime->format(DateTime::ATOM);
        // echo $tiempo;
        // exit;
        //echo "************************************<br>";
        //echo $datetime->format(DateTime::ISO8601);
        //echo "************************************<br>";
        //echo "2023-06-13T11:58:30.804-04:00";

        //echo $fecha_actual;
        // exit;
        // //$arrDatos=$_POST["datos"];

        // echo "*******************\n";
        // for ($i = 0; $i < count($ids_facturas_a_pagar); $i++) {
        //     # code...
        //     echo $ids_facturas_a_pagar[$i] . "-----";
        // }
        // exit;
        //*************funca***************** */
        $client_id = "099e0d61-f558-4c46-b816-cc8fee3321e6";
        $invoice_ids = $ids_facturas_a_pagar; //["4c81932a-2bbc-4a35-b372-878f61ba508a", "34592a3e-6d74-4a3e-b562-da4f25e61cad", "c6694599-970c-4677-9376-7f8de1c0a192"];
        $amount = $montoTotal;
        $payment_date = $tiempo; //"2023-06-13T17:35:54.804-04:00";
        $comment = "Pago realizado por porfy";

        //$token4 = 'https://internethome.smartolt.com/api/onu/enable_catv/' . $id; 
        $token4 = 'https://www.cloud.wispro.co/api/v1/invoicing/payments';
        //dd($token4);
        $responsePago = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->post($token4, [
            'client_id' => $client_id,
            'invoice_ids' => $invoice_ids,
            'amount' => $amount,
            'payment_date' => $payment_date,
            'comment' => $comment
        ]);

        //activa Cattv
        $url_cattv = 'https://internethome.smartolt.com/api/onu/enable_catv/' . $cutom_id; //$request->token;
        //dd($token4);

        $email = 'porfirio@gmail.com';
        $address = 'Zona Porvenir';
        $responseCatv = Http::withHeaders([
            'X-Token' => 'f4937d81d82741668155119e82b13a8f',
            'Accept' => 'application/json',

        ])->post($url_cattv);

        $datosPago = json_decode($responsePago);
        $datosCattv = json_decode($responseCatv);
        // $datos2 = $datos->data;
        //$datos2 = $datos;
        //dd($datos2);

        return response()->json([
            'pagorealizado' => $datosPago,
            'cattv' => $datosCattv
        ], 200);

        //*************fin funca************* */
    }

    public function actualizar_cliente($id, Request $request)
    {

        $ruta = 'https://www.cloud.wispro.co/api/v1/clients/' . $id; //$request->token;       

        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'Accept' => 'application/json',

        ])->put($ruta, [
            'email' => $request->email,
            //$request->limit,           
            'address' => $request->address,
            //$request->page,
            'phone_mobile' => $request->phone_mobile,
            //$request->page,
            'details' => $request->details,
            //$request->page,
            'kind_person' => $request->kind_person,
        ]);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        $datos = json_decode($response, true);
        //   return response()->json($datos);
        if ($datos['status'] == 200) {
            $client = Client::where('custom_id', $request->custom_id)->first();
            $client->email = $request->email;
            $client->phone_mobile = $request->phone_mobile;
            $client->update();
            return response()->json([
                'status' => $datos['status'],
                'fact' => $request->kind_person,
                'message' => 'Cliente actualizado correctamente',
            ], 200);
        } else if ($datos['status'] == 400) {
            return response()->json([
                'status' => $datos['status'],
                'message' => 'Hubo un error al actualizar o el correo ya existe',
            ], 422);
        } else {
            return response()->json([
                'status' => $datos['status'],
                'message' => 'Hubo un error al actualizar al cliente',
            ], 400);
        }
    }
    public function ver_facturas($id, Request $request)
    {
        //saldo
        $responseBalance = Helpers::getBalance($id);
        $balance = json_decode($responseBalance);
        //obtengo facturas pagadas
        $client = Client::select('id', 'name', 'custom_id', 'national_identification_number', 'email')->where("id_wispro", $id)->first();
        // $client->pagos->where("client_id", $client->id)->get();
        $pago = Pago::select('VoucherId', 'TransactionDateTime', 'monto', 'numeroFactura')->where("client_id", $client->id)->get();


        return response()->json([
            'balance' => $balance,
            'pago' => $pago
        ], 200);
    }
    public function mis_facturas_pagadas($id, Request $request)
    {
        $vector = [];
        try {
            $clients = Client::where("user_id", $id)->get()->all();
            //  return $clients;
            foreach ($clients as $client) {
                $facturas = ImagenQr::where("client_id", $client->id)
                    ->where("activo", "=", 1)
                    ->where("statusId", "!=", 3)

                    ->get();
                if (count($facturas) > 0) {
                    // $vector[] = $facturas;
                    array_push($vector, $facturas);
                }
                # code...
            }
            $flattened = Arr::flatten($vector);
            return response()->json([
                'success' => true,
                'facturas' => $flattened,
            ], 200);
            // return $flattened;
            // try {
            //     $clients = Client::where("user_id", $id)->first();

            //     $facturas = ImagenQr::where("client_id", $clients->id)
            //         ->where("activo", "=", 1)
            //         ->where("statusId", "!=", 3)

            //         ->get()->all();
            //     //$facturas = Factura::where("client_id", $clients->id)->orderBy('created_at', 'desc')->first();
            //     // return $facturas;
            //     $facturasAll = $facturas;
            //     $totalFacturas = [];

            /*         
                      if (count($facturas)) {
                          foreach ($facturasAll as $factura) {
                              # code...
                              $imageQR = ImagenQr::where("id", $factura->imagen_qr_id)->first();
                              $totalFacturas[] = [
                                  'custom_id' => $factura->custom_id,
                                  'created_at' => $factura->created_at,
                                  'periodo' => $factura->periodo,
                                  'amount' => $factura->amount,
                                  'estado' => $factura->estado,
                                  'qr' => $imageQR->imageQr,
                              ];
                          }
                          return response()->json([
                              'success' => true,
                              'facturas' => $totalFacturas,
                          ], 200);
                      } else {
                          return response()->json([
                              'success' => false,
                              'mensaje' => 'No tiene facturas pagadas'
                          ], 200);
                      }
          */
        } catch (\Exception $e) {
            return response()->json([
                'success' => false,
                'mensaje' => 'Sr. Cliente hubo un error al obtener las facturas pagadas.' . $e,

            ]);
        }
    }
    public function obtener_estado_contrato_cliente($client_id_eq)
    {
        // https: //www.cloud.wispro.co/api/v1/contracts?client_id_eq=e67399f4-0fb7-4761-aea0-4c6c35b6d926
        //https://www.cloud.wispro.co/api/v1/contracts?client_national_identification_number_eq=1234567


        //Verificar estado CatTv en el contrato de Wispro
        // DOnde busca el estado
        $url = 'contracts?client_id_eq=';
        $responseStatus = Helpers::peticionGetWispro($url, $client_id_eq);
        $datosStatus2 = json_decode($responseStatus);
        $datosStatus = json_decode($responseStatus, true);
        // $datosArray = json_decode($responseStatus, true);
        $dataContrato = $datosStatus['data'];
        $estadoContratoWispro = '';
        foreach ($dataContrato as $contrato) {
            //  echo ' visited ' . $country['id'] . ' in ' . $country['invoice_number'] . 'P.\n';
            //  $ids_facturas_a_pagar[] = $country['id'];
            $estadoContratoWispro = $contrato['state'];
            $lat = $contrato['latitude'];
            $long = $contrato['longitude'];
        }

        // Obtenemos el customId de wispro
        $url = 'clients/';

        $custom = Helpers::obtenerCustomIdClientWispro($url, $client_id_eq);
        $custom = json_decode($custom, true);
        $custom = $custom['data'];
        $customID = $custom['custom_id'];
        if ($estadoContratoWispro == 'disabled') {
            // echo "catTv esta : " . $montoTotal;
            // echo "<br>";
            // echo $customID;
            $resp = Helpers::deshabilitar_cattv($customID);
        } elseif ($estadoContratoWispro == 'enabled') {
            $resp = Helpers::habilitar_cattv($customID);
        }


        $custom = json_decode($resp, true);
        //$responseSmart = $custom['response'];

        return response()->json($datosStatus2->data, 200);
    }
    public static function realizarPagoDespuesDeBnb($QRId)
    {
        $uuid = '6d2faf45-5770-46ab-9dae-a44530131390'; //client uuid
        $uuid = 'e7a3bfb4-c36b-4a14-b060-0918c98f2512'; //client uuid
        $uuid = '9d41b652-b7dd-4a8e-a917-a5b65285fd85'; //client uuid
        // {
        //     "id": "5c9f6444-98d7-4c72-8394-725a3a79f77c", //uuid contrato
        //     "state": "disabled",
        //     "precio": 286
        // }
        $estadoYprecio = Helpers::obtenerEstadoDelContratosXuuid($uuid);

        return $estadoYprecio;
        date_default_timezone_set('America/La_Paz');
        $fechaLimite = date('10-m-Y');
        $fechaActual = date('9-m-Y');
        // $fechaComoEntero = strtotime($factura['issued_at']);
        $fechaLimit = strtotime($fechaLimite);
        $fechaActu = strtotime($fechaActual);
        if ($fechaActu > $fechaLimit) {

            return 'La fecha es mayor' . $fechaActual;
        } else {
            return 'La fecha es menor' . $fechaActual;
        }
        // return $fechaActual;
    }
    public static function eliminarQr($QRId, Request $request)
    {
        $todos_los_datos = $request->all();
        // return $todos_los_datos['qr_id'];
        $authBnb = Helpers::tokenAuthBnb();
        $success = $authBnb['success'];
        $tokenBnb = $authBnb['message'];

        try {
            if ($success) {
                $qr = Qr::find($todos_los_datos['qr_id']);

                $status = Helpers::statusQrBnb($tokenBnb, $qr->qr_id);

                $successStatus = $status['success'];
                $successStatusId = $status['statusId'];
                if ($successStatus && $successStatusId != 2) {
                    $eliminarQrBnb = Helpers::eliminarQrBnb($tokenBnb, $qr->qr_id);
                    $successEliminar = $eliminarQrBnb['success'];

                    if ($successEliminar) {
                        Log::info("Probando " . $successEliminar);
                        $imagenQr = ImagenQr::where('qr_id', '=', $qr->id)->first();


                        $updateImage = ImagenQr::find($imagenQr->id);
                        // $updateImage->estado = 5; //estado=5 elimando
                        // $updateImage->activo = 2;
                        // $updateImage->mensaje = 'eliminado por el cliente ' . $imagenQr->custom_id; //estado=5 elimando
                        // $updateImage->update();
                        // Delete 
                        $pago_adelantado_count = PagoAdelantado::where('imagen_qr_id', $imagenQr->id)->count();
                        Log::info("pago_adelantado_count " . $pago_adelantado_count);
                        if ($pago_adelantado_count > 0) {
                            $pago_adelantado = PagoAdelantado::where('imagen_qr_id', $imagenQr->id)->first();
                            Log::info("pago_adelantado " . $pago_adelantado);
                            $pago_adelantado->delete();
                        }
                        Log::info("salio del if pagoAdelantado ");
                        $current_factura = Factura::where('imagen_qr_id', $imagenQr->id)->get();
                        Log::info("current_factura " . $current_factura);
                        foreach ($current_factura as $factura) {
                            $current_pagoWispro = PagoWispro::find($factura->id);
                            Log::info("current_pagoWispro " . $current_pagoWispro);
                            $current_pagoWispro->delete();
                        }
                        Log::info("salio del foreaech");
                        $current_factura_count = Factura::where('imagen_qr_id', $imagenQr->id)->count();
                        // if ($current_factura_count > 0) {
                        Log::info("current_factura_count " . $current_factura_count);
                        $current_factura = Factura::where('imagen_qr_id', $imagenQr->id)->delete();
                        //}
                        Log::info("current_imageQr ANTESSS" . $qr->id);
                        $current_imageQr = ImagenQr::find($todos_los_datos['id']);
                        Log::info("current_imageQr ANTESSS" . $current_imageQr);
                        $current_imageQr->statusId = 5;
                        $current_imageQr->activo = 2;
                        $current_imageQr->save();


                        // $current_imageQr->delete();
                        // $current_imageQr = Qr::find($qr->id);
                        // $current_imageQr->delete();


                        // $qr = Qr::find($qr->id);
                        // Log::info("current_imageQr " . $qr);
                        // $qr->qr_id = "000";
                        // $qr->save();
                        return response()->json([
                            'success' => true,
                            'data' => 'Qr eliminado correctamente77',
                        ], 200);
                    } elseif ($successStatusId == 1 || $successStatusId == 3 ||  $successStatusId == 4) {
                        Log::info("por elseif " . $successEliminar . " estado::" . $successStatusId);
                        $imagenQr = ImagenQr::where('qr_id', '=', $qr->id)->first();
                        $imagenQr->statusId = 5;
                        $imagenQr->activo = 2;
                        $imagenQr->save();

                        $updateImage = ImagenQr::find($imagenQr->id);

                        Log::info("imagenQr222222222222 " . $imagenQr . " id::" . $imagenQr->id);
                        // $updateImage->estado = 5; //estado=5 elimando
                        // $updateImage->activo = 2;
                        // $updateImage->mensaje = 'eliminado por el cliente ' . $imagenQr->custom_id; //estado=5 elimando
                        // $updateImage->update();
                        // Delete 
                        $pago_adelantado_count = PagoAdelantado::where('imagen_qr_id', $imagenQr->id)->count();
                        Log::info("cantidad de pagosAdelantado " . $pago_adelantado_count);
                        if ($pago_adelantado_count > 0) {
                            $pago_adelantado = PagoAdelantado::where('imagen_qr_id', $imagenQr->id)->first();
                            $pago_adelantado->estado = 1;
                            $pago_adelantado->save();
                        }
                        $current_factura = Factura::where('imagen_qr_id', $imagenQr->id)->get();
                        Log::info("current_factura " . $current_factura);
                        // foreach ($current_factura as $factura) {
                        //     $current_pagoWispro = PagoWispro::Find($factura->id);
                        //     $current_pagoWispro->delete();
                        // }
                        //   $current_factura = Factura::where('imagen_qr_id', $imagenQr->id)->delete();

                        Log::info("qr->id :::" . $qr->id);
                        $current_imageQr = ImagenQr::where('qr_id', $qr->id)->first();
                        Log::info("current_imageQr " . $current_imageQr);
                        $current_imageQr->statusId = 5;
                        $current_imageQr->activo = 2;
                        $current_imageQr->save();
                        $qr = Qr::find($qr->id);
                        Log::info("current_imageQr " . $qr);
                        $qr->qr_id = "000";
                        $qr->save();
                        return response()->json([
                            'success' => true,

                            'data' => 'Qr eliminado correctamente77',
                        ], 200);
                    } else {
                        return response()->json([
                            'status' => 422,
                            'success' => false,
                            'successStatusId' =>  $successStatusId,
                            'eliminarQrBnb' => $eliminarQrBnb,
                            'successEliminar' => $successEliminar,
                            'data' => $eliminarQrBnb['message'],
                        ], 422);
                    }
                } else {

                    return response()->json([
                        'success' => false,
                        'successStatus' => $successStatus,
                        'successStatusId' => $successStatusId,
                        'data' => $status,
                    ], 422);
                }
            }
            return response()->json([
                'success' => false,
                'data' => $authBnb,
            ], 422);
        } catch (\Exception $e) {
            Log::error("ErrorEEEEEEEEEEEEEEEE  " . $e);
            return response()->json([
                'success' => false,
                'data2' => $e,
            ], 422);
        }
    }
    public function resumen_contrato($id, Request $request)
    {
        $result = Helpers::obtenerEstadoDelContratosXuuid($id);
        return $result;
    }
    public function adicionar_lista(Request $request)
    {
        // return $request->id;
        $request->validate([
            "custom_id" => "required|unique:wisprocrons,custom_id",
        ], [
            'custom_id.required' => 'EL código de cliente es requerido',
            'custom_id.unique' => 'El código de cliente ya se encuentra registrado',
        ]);
        try {
            $clientId = $request->id;
            $customId = $request->custom_id;
            $name = $request->name;
            // obtener el contrato
            $result = Helpers::obtenerEstadoDelContratosXuuid($clientId);
            $contratoId = $result['id'];
            $planId = $result['plan_id'];
            $latitude = $result['latitude'];
            $longitude = $result['longitude'];
            $state = $result['state'];
            // obtener precio del Plan
            $precio = Helpers::obtenerPlanXContratoId($planId);

            $wis = new Wisprocron();
            $wis->client_id = $clientId;
            $wis->custom_id = $customId;
            $wis->name = $name;
            $wis->contrato_id = $contratoId;
            $wis->plan_id = $planId;
            $wis->latitude = $latitude;
            $wis->longitude = $longitude;
            $wis->precio = $precio;
            $wis->state = $state;
            $wis->estado = true;
            $wis->save();
            // Deshabilitamos Wispro
            //  $resultWispro = Helpers::deshabilitarContrato($contratoId);
            // Deshabilitamos Smart
            $resultSmart = Helpers::deshabilitar_cattv($customId);
            $result = Helpers::rebootSmart($customId);
            return response()->json([
                "success" => true,
                "status" => 201,
                "mensaje" => "Cliente adicionado exitosamente a la lista Negra.",
            ], 201);
        } catch (\Exception $e) {
            return response()->json([
                "success" => false,
                "status" => 422,
                "mensaje" => $e,
            ]);
        }

        return $result;
    }
    public function pruebaCron($per_page)
    {



        //array tiene todos los clientes de wispro =>client_id, custom_id
        // $prueba = [];
        $prueba = [

            array("client_id" => "cc15ad89-2b9d-4dd1-be9f-acb2137d5f0b", "custom_id" => "200020"),
            array("client_id" => "04fbb72b-6885-47b6-b3db-5bd03ad71026", "custom_id" => "200022"),
            array("client_id" => "a16b7dfd-20ee-4e57-8dc9-a0411aee0c01", "custom_id" => "200024"),
            array("client_id" => "6d2faf45-5770-46ab-9dae-a44530131390", "custom_id" => "200042"),
            array("client_id" => "3aa54cb8-ce91-44c2-8d0e-c857ef2fecd5", "custom_id" => "200044"),
            array("client_id" => "e7a3bfb4-c36b-4a14-b060-0918c98f2512", "custom_id" => "200047"),
            array("client_id" => "9d41b652-b7dd-4a8e-a917-a5b65285fd85", "custom_id" => "200041"),

        ];
        // custom_id 200020     286     deshabilitado    
        // custom_id 200022     258     deshabilitado
        // custom_id 200024     138     habilitado
        // custom_id 200042     178     deshabilitado
        // custom_id 200044     208     deshabilitado
        // custom_id 200047     258     habilitado
        // custom_id 200041     286     alerted


        // return $prueba;
        //{
        //    "client_id": "e67399f4-0fb7-4761-aea0-4c6c35b6d926",
        //    "custom_id": "210012"
        //},

        $TodosLosClientesWispro = Helpers::obtenerTodosLosClientesWispro();


        //$uuid = 'efd44de5-6b2f-4a98-9cc5-6f501b605933';
        //tiene => estado, precio por cliente
        $estadoContrato = Helpers::obtenerEstadoDelContratosXuuid($TodosLosClientesWispro['client_id']);
        // {
        //     "state": "alerted",
        //     "precio": 138
        // }
        // 100 138 siempre deshabilitados SMART deshabilitado
        //siempre que se a mayor a 178 y este alertado o habilitado en wiaspro en smart habilitado catTV

        $plan = Plan::find(1);

        return $plan->precio;
        foreach ($TodosLosClientesWispro as $cliente) {
            // foreach ($prueba as $cliente) {
            $estadoContrato = Helpers::obtenerEstadoDelContratosXuuid($cliente['client_id']);

            if ($estadoContrato['precio'] > $plan->precio) {
                if ($estadoContrato['state'] == 'enabled') {
                    //  Helpers::habilitar_cattv($cliente['custom_id']);
                } elseif ($estadoContrato['state'] == 'disabled') {
                    // Helpers::deshabilitar_cattv($cliente['custom_id']);
                } elseif ($estadoContrato['state'] == 'alerted') {
                    //Helpers::habilitar_cattv($cliente['custom_id']);
                }
            } else {
                //Helpers::deshabilitar_cattv($cliente['custom_id']);
            }
        }

        return response()->json([
            'Success' => true,
            'mensaje' => 'Actualizacion correcta',
        ], 200);

        return $estadoContrato;
        $dataCustomIdsClients = $responseTodosLosClientesWispro['data'];
        $datosContratoObjData = $datosContratoData[0];
        $datosContratoPlanId = $datosContratoObjData['plan_id'];
        $datosContratoState = $datosContratoObjData['state'];
        // peticion Plan
        $url22 = 'plans/';

        $responsePlan = Helpers::peticionGetWispro($url22, $datosContratoPlanId);
        $datosPlan = json_decode($responsePlan, true);
        $datosPlanData = $datosPlan['data'];
        $datosPlanPrecio = $datosPlanData['price'];

        $estadoContratoWispro = '';
        // Obtenemos el customId de wispro
        $url = 'clients/';
        $custom = Helpers::peticionGetWispro($url, $client_id_eq);
        $custom = json_decode($custom, true);
        $custom = $custom['data'];
        $customID = $custom['custom_id'];
        if ($datosPlanPrecio == 138) {
            if ($datosContratoState == 'disabled') {
                $resp = Helpers::deshabilitar_cattv($customID);
            } elseif ($datosContratoState == 'enabled') {
                $resp = Helpers::habilitar_cattv($customID);
            }
        }
        return response()->json($customID, 200);
        /*
        return response()->json([
            'datosContratoPlanId' => $datosContratoPlanId,
            'datosContratoState' => $datosContratoState,
            'datosContratoData' => $datosContratoData,
        ], 200);*/
    }
    public function compararCiWisproDB($customId, Request $request)
    {
        //return 
        //  $clientwi->id;


        $estado = false;
        $cliente = new stdClass();
        $vec = [];
        try {

            $clientwispro = Helpers::obtenerClienteWisproXUUId($customId);
            $cliente->clientwis = $clientwispro;

            //return $clientwispro->id;
            $cliente->estado_contrato = Helpers::obtenerEstadoDelContratoCliente($request->id);
            $clientedb = Client::select('id', 'custom_id', 'name', 'email', 'address', 'phone_mobile', 'national_identification_number')->where('custom_id', $customId)->where('id_wispro', $request->id)->first();
            // return $clientedb->id;
            // foreach ($clientedb['data'] as $clie) {
            # code...
            if ($clientedb->custom_id == $clientwispro->custom_id) {
            } else {
                $estado = true;
                array_push($vec, [$clientedb->custom_id, $clientwispro->custom_id]);
            }
            if ($clientedb->name == $clientwispro->name) {
            } else {
                $estado = true;
                array_push($vec, [$clientedb->name, $clientwispro->name]);
            }
            if ($clientedb->email == $clientwispro->email) {
            } else {
                $estado = true;
                array_push($vec, [$clientedb->email, $clientwispro->email]);
            }
            if ($clientedb->address == $clientwispro->address) {
            } else {
                $estado = true;
                array_push($vec, [$clientedb->address, $clientwispro->address]);
            }
            if ($clientedb->phone_mobile == $clientwispro->phone_mobile) {
            } else {
                $estado = true;
                array_push($vec, [$clientedb->phone_mobile, $clientwispro->phone_mobile]);
            }
            if ($clientedb->national_identification_number == $clientwispro->national_identification_number) {
            } else {
                $estado = true;
                array_push($vec, [$clientedb->national_identification_number, $clientwispro->national_identification_number]);
            }
            // $cliente->id = $clie['id'];
            // $cliente->custom_id = $clie['custom_id'];
            // $cliente->name = $clie['name'];
            // $cliente->email = $clie['email'];
            // $cliente->address = $clie['address'];
            // $cliente->phone_mobile = $clie['phone_mobile'];
            // $cliente->national_identification_number = $clie['national_identification_number'];
            //}
            $cliente->estado_contrato = Helpers::obtenerEstadoDelContratoCliente($request->id);
            $cliente->clientedb = Client::select('id', 'custom_id', 'name', 'email', 'address', 'phone_mobile', 'national_identification_number')->where('custom_id', $customId)->where('id_wispro', $request->id)->first();
            $cliente->estado = $estado;
            return response()->json([

                "success" => true,
                "status" => 200,
                "compa" => $vec,
                "data" => $cliente,

            ], 200);
        } catch (\Exception $e) {
            return response()->json([

                "success" => false,
                "status" => 422,
                "data" => "Error en la peticion " . $e,

            ], 422);
        }
    }
    public function sincronizarCiWisproDB($id, Request $request)
    {
        $request->validate([

            "id" => "required|exists:clients,id_wispro",
            "custom_id" => "required|exists:clients,custom_id",

        ], [
            'id.required' => 'El id del cliente es requerido',
            'id.exists' => 'El id del cliente no se encuentra registrado',
            'custom_id.required' => 'El código de cliente es requerido',
            'custom_id.exists' => 'El código del cliente no se encuentra registrado',
        ]);



        $estado = false;
        $cliente = new stdClass();
        $vec = [];
        // obtenemos informacion de wispro
        $clientwispro = Helpers::obtenerClienteWisproXUUId($request->custom_id);
        DB::beginTransaction();


        try {
            $cliente->estado_contrato = Helpers::obtenerEstadoDelContratoCliente($request->id);

            $updateClientedb = Client::where('custom_id', $request->custom_id)->where('id_wispro', $request->id)->first();

            // $updateClientedb->id = $clie['id'];
            // $updateClientedb->custom_id = $clie['custom_id'];

            $updateClientedb->name = $clientwispro->name;
            $updateClientedb->email = $clientwispro->email;
            $updateClientedb->address = $clientwispro->address;
            $updateClientedb->phone_mobile = $clientwispro->phone_mobile;
            $updateClientedb->national_identification_number = $clientwispro->national_identification_number;
            $updateClientedb->save();

            $user = User::find($updateClientedb->user_id);
            $user->password = bcrypt($clientwispro->national_identification_number);
            $user->save();
            DB::commit();
            return response()->json([

                "success" => true,
                "status" => 201,
                "message" => "Cliente actualizado con exito",

            ], 201);
        } catch (\Exception $e) {
            DB::rollback();
            return response()->json([

                "success" => false,
                "status" => 422,
                "message" => "Error en la peticion " . $e,

            ], 422);
        }
    }
}
