<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('pago_sintesis', function (Blueprint $table) {
            $table->id();
            $table->string('codigoRecaudacion'); //El código de recaudación a la que pertenece la transacción String
            $table->string('codigoProducto'); //Código de producto String
            $table->integer('numeroPago'); //Número de Pago Int
            $table->integer('fecha'); //fecha de pago Int
            $table->integer('secuencial'); //Secuencial de la Transacción  Int
            $table->integer('hora'); //Hora de la Transacción  Int
            $table->string('origenTransaccion'); //Origen de la Transacción String
            $table->integer('pais'); //País del Operador  Int
            $table->integer('departamento'); //Departamento del Operador  Int
            $table->integer('ciudad'); //Ciudad del Operador  Int
            $table->string('entidad'); //Entidad del Operador String
            $table->string('agencia'); //Agencia del Operador String
            $table->integer('operador'); //Código del Operador Int
            $table->double('monto'); //Monto de de la Transacción Double
            $table->integer('loteDosificacion'); //Lote de Dosificación Int
            $table->string('nroRentaRecibo'); //Numero Renta Recibo String
            $table->double('montoCreditoFiscal'); //Monto de Crédito Fiscal  Double
            $table->string('codigoAutorizacion')->nullable(); //Código de Autorización String
            $table->string('codigoControl')->nullable(); //Código de Control String
            $table->string('nitFacturar')->nullable(); //Nit a Facturar String
            $table->string('nombreFacturar')->nullable(); //Nombre a Facturar String
            $table->string('transaccion'); //ipo de Transacción P = Pagado, R = Revertido o Anulado String
            $table->integer('status')->default(0)->nullable();
            $table->integer('activo')->default(0)->nullable();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('pago_sintesis');
    }
};
