<?php

namespace Vdhicts\ValidationRules\Rules;

use Illuminate\Contracts\Validation\Rule;
use Illuminate\Support\Str;

class NotContains implements Rule
{
    public function __construct(private readonly string $needle = '')
    {
    }

    /**
     * Determine if the validation rule passes.
     *
     * @param string $attribute
     * @param mixed $value
     */
    public function passes($attribute, $value): bool
    {
        if ($this->needle === '') {
            return true;
        }

        return ! Str::contains($value, $this->needle);
    }

    /**
     * Get the validation error message.
     */
    public function message(): string
    {
        return sprintf(
            __('validationRules.not_contains'),
            $this->needle
        );
    }
}
